#ifndef ARARTICOLO_H
#define ARARTICOLO_H

#define ARARTICOLO_ADD  0
#define ARARTICOLO_EDIT 1

#include <QWidget>

class QPushButton;
class QGroupBox;
class QComboBox;
class QLineEdit;
class QLabel;
class QMessageBox;
class QRegExp;
class QDate;

class ARFinestra;
class ARsql;

class ARArticolo : public QWidget
 {
  Q_OBJECT

  public:
   QGroupBox *cornice;
   QPushButton *esegui;
   QLineEdit *art,*descr,*misura,*prezzo,*sconto,*iva,*prezzo_pub;
   QComboBox *listaColore,*listaFondo,*listaTacco,*listaStagione;// listaMisura
   
   ARArticolo(QWidget *parent = 0);
   bool setForm(QString,QString);
   void clearForm();
   void setArticoloID(QString);
   void setAzione(int);
   bool isAzione(int);
   void populateListe();
   void settaInfo(QString,QString,QString,QString,QString,QString);
   
  public slots:
   void addArticolo();
   
  private:
   ARFinestra *mainWin;
   ARsql *sql;
   QMessageBox *infobox,*warnbox;
   QString articoloID;
   QLabel *_art,*_descr,*_misura,*_prezzo,*_sconto,*_iva,*_prezzo_pub;
   QLabel *_colore,*_fondo,*_tacco,*_stagione;
   QLabel *_infoart,*info;
   QRegExp *reg_email;
   int azione;

   bool checkForm();
   bool populateOption(QComboBox *,QString,QString);
   QString prendiOptionID(QString,QString);
   QString quote(QString, bool like = false);
 };

#endif
