#include <QPushButton>
#include <QGroupBox>
#include <QLabel>
#include <QLineEdit>
#include <QTextEdit>
#include <QMessageBox>
#include <QRegExp>

#include "ARsql.h"
#include "ARMainMenu.h"
#include "ARBarra.h"
#include "ARDialogProv.h"
#include "ARDialogCAP.h"
#include "ARFinestra.h"

#include "ARAzienda.h"

ARAzienda::ARAzienda(QWidget *parent) : QWidget(parent)
 {
 	mainWin=(ARFinestra *)parent;
 	sql = new ARsql(this);
 	provbox = new ARDialogProv(this);
 	capbox  = new ARDialogCAP(this); 	
 	infobox = new QMessageBox(tr("Informazioni"),"",QMessageBox::Question,0,0,0,this);
 	warnbox = new QMessageBox(tr("Avviso"),"",QMessageBox::Warning,0,0,0,this);
 	cornice = new QGroupBox(tr("Inserisci i dati della tua azienda "),this);
 	cornice->setGeometry(2,0,650,420);

  _nome  = new QLabel(tr("Nome azienda"),this);   _nome->setGeometry ( 10,  20,  80, 24);
   nome  = new QLineEdit("",this);                nome->setGeometry  ( 85,  20, 550, 24);
  _indr  = new QLabel(tr("Indirizzo"),this);      _indr->setGeometry ( 10,  50,  80, 24);
   indr  = new QLineEdit("",this);                indr->setGeometry  ( 85,  50, 550, 24);
  _cap   = new QLabel(tr("C.A.P."),this);         _cap->setGeometry  ( 10,  80,  80, 24);
   cap   = new QLineEdit("",this);                cap->setGeometry   ( 85,  80,  42, 24);
  cercap = new QPushButton(QIcon("pic/cerca.png"),"",this);
  cercap->setGeometry(131,80,24,24);
  _citta = new QLabel(tr("Citt"),this);          _citta->setGeometry(160,  80,  80, 24);
   citta = new QLineEdit("",this);                citta->setGeometry (190,  80, 310, 24);
  _prov  = new QLabel(tr("Provincia"),this);      _prov->setGeometry (510,  80,  80, 24);
   prov  = new QLineEdit("",this);                prov->setGeometry  (565,  80,  40, 24);
  cercapr = new QPushButton(QIcon("pic/cerca.png"),"",this);
  cercapr->setGeometry(611,80,24,24);
  _nazio = new QLabel(tr("Nazione"),this);        _nazio->setGeometry( 10, 110,  80, 24);
   nazio = new QLineEdit(tr("Italia"),this);      nazio->setGeometry ( 85, 110, 550, 24);
  _tel   = new QLabel(tr("Telefono"),this);       _tel->setGeometry  ( 10, 140,  80, 24);
   tel   = new QLineEdit("",this);                tel->setGeometry   ( 85, 140, 150, 24);
  _fax   = new QLabel(tr("Fax"),this);            _fax->setGeometry  (245, 140,  80, 24);
   fax   = new QLineEdit("",this);                fax->setGeometry   (275, 140, 150, 24);
  _cell  = new QLabel(tr("Cellulare"),this);      _cell->setGeometry (435, 140,  80, 24);
   cell  = new QLineEdit("",this);                cell->setGeometry  (485, 140, 150, 24);
  _piva  = new QLabel(tr("Partita IVA"),this);    _piva->setGeometry ( 10, 170,  80, 24);
   piva  = new QLineEdit("",this);                piva->setGeometry  ( 85, 170, 550, 24);
  _datiweb = new QLabel(tr("<b>Dati internet:</b>"),this); _datiweb->setGeometry(  6, 200,  80, 24);
  _email   = new QLabel(tr("Email"),this);                 _email->setGeometry  ( 10, 230, 150, 24);
   email   = new QLineEdit("",this);                        email->setGeometry  ( 85, 230, 550, 24);
  _sitoweb = new QLabel(tr("Sito web"),this);              _sitoweb->setGeometry( 10, 260, 150, 24);
   sitoweb = new QLineEdit("",this);                        sitoweb->setGeometry( 85, 260, 550, 24);

  nome->setMaxLength(255);
  indr->setMaxLength(255);
  cap->setMaxLength(5);
  citta->setMaxLength(255);
  prov->setMaxLength(2);
  nazio->setMaxLength(255);
  tel->setMaxLength(50);
  fax->setMaxLength(50);
  cell->setMaxLength(50);
  piva->setMaxLength(11);
  email->setMaxLength(255);
  sitoweb->setMaxLength(255);
  reg_email = new QRegExp("^[a-z0-9][_\\.a-z0-9-]+@([a-z0-9][0-9a-z-]+\\.)+([a-z]{2,4})$");
 	esegui = new QPushButton(QIcon("pic/floppy.png"),tr("Salva"),this);
 	esegui->setGeometry(543,393,106,24);
 	stampaint = new QPushButton(QIcon("pic/intestazione.png"),tr("Stampa intest."),this);
  stampaint->setGeometry(543,363,106,24);

  connect(esegui,SIGNAL(clicked()),this,SLOT(addAzienda()));
  connect(cercapr,SIGNAL(clicked()),this,SLOT(cercaProvincia()));
  connect(cercap,SIGNAL(clicked()),this,SLOT(cercaCAP()));

 	infobox->setWindowModality(Qt::WindowModal);
 	warnbox->setWindowModality(Qt::WindowModal);
  setGeometry(0,61,680,440);
  azione=ARAZIENDA_ADD;  
  hide();
 }

void ARAzienda::cercaProvincia()
 {
 	provbox->clearForm();
 	if(provbox->exec()==QDialog::Accepted) prov->setText(provbox->getProvincia());
 }

void ARAzienda::cercaCAP()
 {
 	capbox->visCAP();
 	if(capbox->exec()==QDialog::Accepted)
 	 {
 	 	cap->setText(capbox->getCAP());
 	 	citta->setText(capbox->getCitta());
 	  prov->setText(capbox->getProvincia());
   }
 }

void ARAzienda::addAzienda()
 {
  QString nome=quote(this->nome->text());
  QString indr=quote(this->indr->text());
  QString cap=quote(this->cap->text());
  QString citta=quote(this->citta->text());
  QString prov=quote(this->prov->text());
  QString nazio=quote(this->nazio->text());
  QString tel=quote(this->tel->text());
  QString fax=quote(this->fax->text());
  QString cell=quote(this->cell->text());
  QString piva=quote(this->piva->text());
  QString cf="";
  QString email=quote(this->email->text());
  QString sitoweb=quote(this->sitoweb->text());
  QString ts=sql->timeStamp();
  QString data=sql->data(ts);
  QString ora=sql->ora(ts);

 	if(isAzione(ARAZIENDA_ADD))
 	 {
 	  if(!checkForm())
 	   {
 	   	if(sql->doQuery("INSERT INTO aziende VALUES('0','"+nome+"','"+indr+"','"+cap+"','"+citta+"','"+prov+"','"+nazio+"','"+tel+"','"+fax+"','"+cell+"','"+piva+"','"+cf+"','"+email+"','"+sitoweb+"','"+data+"','"+ora+"','"+ts+"')"))
       {
        infobox->setText(tr("I dati della tua azienda\nsono stati inseriti correttamente!\nAdesso  possibile usare il programma."));
        infobox->exec();
        clearForm();
        hide();
        mainWin->disableAll(false);
        mainWin->mainMenu->show();
 	     }
 	   }
 	 }
 	if(isAzione(ARAZIENDA_EDIT))
 	 {
 	  if(!checkForm())
 	   {
 	 	  if(sql->doQuery("UPDATE aziende SET nome='"+nome+"', indirizzo='"+indr+"', cap='"+cap+"', citta='"+citta+"', provincia='"+prov+"', nazione='"+nazio+"', tel='"+tel+"', fax='"+fax+"', cell='"+cell+"', piva='"+piva+"', cf='"+cf+"', email='"+email+"', sitoweb='"+sitoweb+"' WHERE aziendaID='"+aziendaID+"'"))
 	 	   {
        warnbox->setText(tr("Dati tua azienda modificati e salvati!"));
        warnbox->exec(); 
        hide();
        mainWin->mainMenu->show();
        mainWin->barra->sistemaBarra("");
       }
     }
 	 }
 }

bool ARAzienda::setForm(QString aziendaID)
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;

  rs=sql->doQueryRS("SELECT * FROM aziende WHERE aziendaID='"+aziendaID+"'");
  if(rs)
   {
    if(mysql_num_rows(rs)!=1) { mysql_free_result(rs); return false; }
    row=mysql_fetch_row(rs);
    nome->setFocus();
 	  nome->setText(row[1]);
 	  indr->setText(row[2]);
 	  cap->setText(row[3]);
 	  citta->setText(row[4]);
 	  prov->setText(row[5]);
 	  nazio->setText(row[6]);
 	  tel->setText(row[7]);
 	  fax->setText(row[8]);
 	  cell->setText(row[9]);
 	  piva->setText(row[10]);
 	  email->setText(row[12]);
 	  sitoweb->setText(row[13]);
 	  mysql_free_result(rs);
 	  return true;
 	 }
 	return false;
 }

void ARAzienda::clearForm()
 {
 	nome->setFocus();
 	nome->clear();
 	indr->clear();
 	cap->clear();
 	citta->clear();
 	prov->clear();
 	nazio->setText(tr("Italia"));
 	tel->clear();
 	fax->clear();
 	cell->clear();
 	piva->clear();
 	email->clear();
 	sitoweb->clear();
 }

bool ARAzienda::checkForm()
 {
 	if(quote(this->nome->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire il nome dell'azienda"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(this->piva->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire la partita iva della tua azienda"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(this->piva->text())!="" && quote(this->piva->text()).length()!=11)
 	 {
 	  warnbox->setText(tr("Lunghezza partita iva errata"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(this->email->text())!="" && !reg_email->exactMatch(quote(this->email->text())))
 	 {
 	  warnbox->setText(tr("Formato email errato"));
 	  warnbox->exec();
 	  return true;
 	 }
 	return false;
 }

QString ARAzienda::quote(QString str, bool like)
 {
 	if(like)
 	 {
 	  str.replace('\\',"\\\\\\\\");
 	  str.replace('\'',"\\'");
 	 }
 	else
   {
 	  str.replace('\\',"\\\\");
 	  str.replace('\'',"\\'");
   }
 	return str;
 }

void ARAzienda::setAziendaID(QString aziID) { aziendaID=aziID; }

void ARAzienda::setAzione(int azio) { azione=azio; }

bool ARAzienda::isAzione(int azio) { if(azione==azio) return true; else return false; }
