#ifndef ARCARICO_H
#define ARCARICO_H

#include <QWidget>

class QPushButton;
class QGroupBox;
class QComboBox;
class QLabel;
class QHeaderView;
class QTableWidget;
class QTableWidgetItem;
class QMessageBox;
class QProgressBar;

class ARsql;

class ARCarico : public QWidget
 {
  Q_OBJECT

  public:
   QGroupBox *cornice;
   QPushButton *esegui,*addrow,*updtot,*clsrow;
   QComboBox *listaFor,*listaTipo;
   QComboBox *listaColore,*listaFondo,*listaTacco,*listaStagione;
   QTableWidget *table;
   
   ARCarico(QWidget *parent = 0);
   ~ARCarico();
   void settaGeometria(int,int);
   QStringList getEtichette();
   QStringList getEtichCampi();
   int getRowIva();
   int getRowStartCampi();
   int getTotRows();
   int getTotColumns();
   bool populateFor();
   bool populateTipo();
   bool populateOptionAll(QComboBox *,int,QString);
   bool populateOption(QComboBox *,QString);
   void clearCarico();
   QString getFornitoreID();
   QString getTipoArticoloID();
   QString getElemento(int,int,QString def="");
   void clsRow(int);
   int checkElemento(int,int,int,bool ckint=false,bool ckdouble=false);
   int checkRiga(int);
   bool checkCarico();
   //void setAzione(int);
   //bool isAzione(int);

  public slots:
   void addEmptyRow();
   void updateTot();
   void caricaMerce();
   void clearRiga();

  private:
   QMessageBox *infobox,*yesnobox;
   ARsql *sql;
   QLabel *_for,*_tipo,*_table,*_totali;
   QString *fl_misure,*fl_campi;     // Flag ("0"/"1") per le misure dei vari tipi di articoli
   QStringList etichette,intestazione,etich_campi; // Etichette delle misure ("L", "XL", ecc...)
   QProgressBar *progresso;
   int tot_row,num_mis,num_campi,c_prima,rows_campi,row_iva,row_sconto;
   QString iva,sconto;
   //int azione;
   
   int calcTotali();
   int prendiEtichette();
   QString quote(QString, bool like = false);
   QTableWidgetItem *inserisciRiga(const char *, int alig=Qt::AlignLeft);
   QTableWidgetItem *inserisciRiga(QString, int alig=Qt::AlignLeft);

  private slots:
   void drawInputTipo(int);  
 };

#endif
