#include <QPushButton>
#include <QGroupBox>
#include <QLabel>
#include <QLineEdit>
#include <QTextEdit>
#include <QMessageBox>
#include <QRegExp>

#include "ARsql.h"
#include "ARDialogProv.h"
#include "ARDialogCAP.h"
#include "ARFinestra.h"

#include "ARCliente.h"

ARCliente::ARCliente(QWidget *parent) : QWidget(parent)
 {
 	mainWin=(ARFinestra *)parent;
 	sql = new ARsql(this);
 	provbox = new ARDialogProv(this);
 	capbox  = new ARDialogCAP(this);
 	infobox = new QMessageBox(tr("Informazioni"),"",QMessageBox::Question,0,0,0,this);
 	warnbox = new QMessageBox(tr("Avviso"),"",QMessageBox::Warning,0,0,0,this);
 	cornice = new QGroupBox(tr("Inserisci nuovo cliente "),this);
 	cornice->setGeometry(2,0,650,420);

  _nome  = new QLabel(tr("Nome"),this);           _nome->setGeometry (10,   20,  80, 24);
   nome  = new QLineEdit("",this);                nome->setGeometry  (80,   20, 550, 24);
  _indr  = new QLabel(tr("Indirizzo"),this);      _indr->setGeometry (10,   50,  80, 24);
   indr  = new QLineEdit("",this);                indr->setGeometry  (80,   50, 550, 24);
  _cap   = new QLabel(tr("C.A.P."),this);         _cap->setGeometry  (10,   80,  80, 24);
   cap   = new QLineEdit("",this);                cap->setGeometry   (80,   80,  42, 24);
  cercap = new QPushButton(QIcon("pic/cerca.png"),"",this);
  cercap->setGeometry(126,80,24,24);
  _citta = new QLabel(tr("Citt"),this);          _citta->setGeometry(155,  80,  80, 24);
   citta = new QLineEdit("",this);                citta->setGeometry (185,  80, 310, 24);
  _prov  = new QLabel(tr("Provincia"),this);      _prov->setGeometry (505,  80,  80, 24);
   prov  = new QLineEdit("",this);                prov->setGeometry  (560,  80,  42, 24);
  cercapr = new QPushButton(QIcon("pic/cerca.png"),"",this);
  cercapr->setGeometry  (606,80,24,24);
  _nazio = new QLabel(tr("Nazione"),this);        _nazio->setGeometry( 10, 110,  80, 24);
   nazio = new QLineEdit(tr("Italia"),this);      nazio->setGeometry ( 80, 110, 550, 24);
  _tel   = new QLabel(tr("Telefono"),this);       _tel->setGeometry  ( 10, 140,  80, 24);
   tel   = new QLineEdit("",this);                tel->setGeometry   ( 80, 140, 150, 24);
  _fax   = new QLabel(tr("Fax"),this);            _fax->setGeometry  (240, 140,  80, 24);
   fax   = new QLineEdit("",this);                fax->setGeometry   (270, 140, 150, 24);
  _cell  = new QLabel(tr("Cellulare"),this);      _cell->setGeometry (430, 140,  80, 24);
   cell  = new QLineEdit("",this);                cell->setGeometry  (480, 140, 150, 24);
  _piva  = new QLabel(tr("Partita IVA"),this);    _piva->setGeometry ( 10, 170,  80, 24);
   piva  = new QLineEdit("",this);                piva->setGeometry  ( 80, 170, 230, 24);
  _cf    = new QLabel(tr("Codice fiscale"),this); _cf->setGeometry   (320, 170,  80, 24);
   cf    = new QLineEdit("",this);                 cf->setGeometry   (400, 170, 230, 24);
  _datiweb = new QLabel(tr("<b>Dati internet:</b>"),this); _datiweb->setGeometry(  6, 200,  80, 24);
  _email   = new QLabel(tr("Email"),this);                 _email->setGeometry  ( 10, 230, 150, 24);
   email   = new QLineEdit("",this);                        email->setGeometry  ( 80, 230, 550, 24);
  _sitoweb = new QLabel(tr("Sito web"),this);              _sitoweb->setGeometry( 10, 260, 150, 24);
   sitoweb = new QLineEdit("",this);                        sitoweb->setGeometry( 80, 260, 550, 24);

  _note = new QLabel(tr("<b>Note:</b>"),this); _note->setGeometry(  6, 290,  80, 24);
   note = new QTextEdit("",this);               note->setGeometry( 10, 315, 620, 74);

  nome->setMaxLength(255);
  indr->setMaxLength(255);
  cap->setMaxLength(5);
  citta->setMaxLength(255);
  prov->setMaxLength(2);
  nazio->setMaxLength(255);
  tel->setMaxLength(50);
  fax->setMaxLength(50);
  cell->setMaxLength(50);
  piva->setMaxLength(11);
  cf->setMaxLength(16);
  email->setMaxLength(255);
  sitoweb->setMaxLength(255);
  reg_email = new QRegExp("^[a-z0-9][_\\.a-z0-9-]+@([a-z0-9][0-9a-z-]+\\.)+([a-z]{2,4})$");

 	esegui = new QPushButton(QIcon("pic/clienti_add.png"),tr("Inserisci"),this);
 	esegui->setGeometry(543,393,106,24);

  connect(esegui,SIGNAL(clicked()),this,SLOT(addCliente()));
  connect(cercapr,SIGNAL(clicked()),this,SLOT(cercaProvincia()));
  connect(cercap,SIGNAL(clicked()),this,SLOT(cercaCAP()));

 	infobox->setWindowModality(Qt::WindowModal);
 	warnbox->setWindowModality(Qt::WindowModal);
  setGeometry(0,61,680,440);
  azione=ARCLIENTE_ADD;  
  hide();
 }

void ARCliente::cercaProvincia()
 {
 	provbox->clearForm();
 	if(provbox->exec()==QDialog::Accepted) prov->setText(provbox->getProvincia());
 }

void ARCliente::cercaCAP()
 {
 	capbox->visCAP();
 	if(capbox->exec()==QDialog::Accepted)
 	 {
 	 	cap->setText(capbox->getCAP());
 	 	citta->setText(capbox->getCitta());
 	  prov->setText(capbox->getProvincia());
   }
 }

void ARCliente::addCliente()
 {
  QString nome=quote(this->nome->text());
  QString indr=quote(this->indr->text());
  QString cap=quote(this->cap->text());
  QString citta=quote(this->citta->text());
  QString prov=quote(this->prov->text());
  QString nazio=quote(this->nazio->text());
  QString tel=quote(this->tel->text());
  QString fax=quote(this->fax->text());
  QString cell=quote(this->cell->text());
  QString piva=quote(this->piva->text());
  QString cf=quote(this->cf->text());
  QString email=quote(this->email->text());
  QString sitoweb=quote(this->sitoweb->text());
  QString note=quote(this->note->toPlainText());
  QString ts=sql->timeStamp();
  QString data=sql->data(ts);
  QString ora=sql->ora(ts);

 	if(isAzione(ARCLIENTE_ADD))
 	 {
 	  if(!checkForm())
 	   {
 	   	if(sql->doQuery("INSERT INTO clienti VALUES('0','"+nome+"','"+indr+"','"+cap+"','"+citta+"','"+prov+"','"+nazio+"','"+tel+"','"+fax+"','"+cell+"','"+piva+"','"+cf+"','"+email+"','"+sitoweb+"','"+note+"','"+data+"','"+ora+"','"+ts+"')"))
       {
        infobox->setText(tr("Nuovo cliente inserito"));
        infobox->exec();
        clearForm();
 	     }
 	   }
 	 }
 	if(isAzione(ARCLIENTE_EDIT))
 	 {
 	  if(!checkForm())
 	   {
 	 	  if(sql->doQuery("UPDATE clienti SET nome='"+nome+"', indirizzo='"+indr+"', cap='"+cap+"', citta='"+citta+"', provincia='"+prov+"', nazione='"+nazio+"', tel='"+tel+"', fax='"+fax+"', cell='"+cell+"', piva='"+piva+"', cf='"+cf+"', email='"+email+"', sitoweb='"+sitoweb+"', note='"+note+"' WHERE clienteID='"+clienteID+"'"))
 	 	   {
        warnbox->setText(tr("Cliente modificato e salvato!"));
        warnbox->exec(); 
        mainWin->visClienti();
       }
     }
 	 }
 }

bool ARCliente::setForm(QString clienteID)
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;

  rs=sql->doQueryRS("SELECT * FROM clienti WHERE clienteID='"+clienteID+"'");
  if(rs)
   {
    if(mysql_num_rows(rs)!=1) { mysql_free_result(rs); return false; }
    row=mysql_fetch_row(rs);
    nome->setFocus();
 	  nome->setText(row[1]);
 	  indr->setText(row[2]);
 	  cap->setText(row[3]);
 	  citta->setText(row[4]);
 	  prov->setText(row[5]);
 	  nazio->setText(row[6]);
 	  tel->setText(row[7]);
 	  fax->setText(row[8]);
 	  cell->setText(row[9]);
 	  piva->setText(row[10]);
 	  cf->setText(row[11]);
 	  email->setText(row[12]);
 	  sitoweb->setText(row[13]);
 	  note->setPlainText(row[14]);
 	  mysql_free_result(rs);
 	  return true;
 	 }
  return false;
 }

void ARCliente::clearForm()
 {
 	nome->setFocus();
 	nome->clear();
 	indr->clear();
 	cap->clear();
 	citta->clear();
 	prov->clear();
 	nazio->setText(tr("Italia"));
 	tel->clear();
 	fax->clear();
 	cell->clear();
 	piva->clear();
 	cf->clear();
 	email->clear();
 	sitoweb->clear();
 	note->clear();
 }

bool ARCliente::checkForm()
 {
 	if(quote(this->nome->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire il nome del cliente"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(this->piva->text())=="" && quote(this->cf->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire la partita iva oppure il codice fiscale del cliente"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(this->piva->text())!="" && quote(this->cf->text())!="")
 	 {
 	  warnbox->setText(tr("Devi inserire la partita iva oppure il codice fiscale del cliente\nnon entrambi"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(this->piva->text())!="" && quote(this->piva->text()).length()!=11)
 	 {
 	  warnbox->setText(tr("Lunghezza partita iva errata"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(this->cf->text())!="" && quote(this->cf->text()).length()!=16)
 	 {
 	  warnbox->setText(tr("Lunghezza codice fiscale errata"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(this->email->text())!="" && !reg_email->exactMatch(quote(this->email->text())))
 	 {
 	  warnbox->setText(tr("Formato email errato"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(this->note->toPlainText()).length()>1024)
 	 {
 	  warnbox->setText(tr("Campo note troppo lungo,\nmassimo 1000 caratteri."));
 	  warnbox->exec();
 	  return true;
 	 }
 	return false;
 }

QString ARCliente::quote(QString str, bool like)
 {
 	if(like)
 	 {
 	  str.replace('\\',"\\\\\\\\");
 	  str.replace('\'',"\\'");
 	 }
 	else
   {
 	  str.replace('\\',"\\\\");
 	  str.replace('\'',"\\'");
   }
 	return str;
 }

void ARCliente::setClienteID(QString cliID) { clienteID=cliID; }

void ARCliente::setAzione(int azio) { azione=azio; }

bool ARCliente::isAzione(int azio) { if(azione==azio) return true; else return false; }
