#include <QPushButton>
#include <QLabel>
#include <QTableWidget>
#include <QTableWidgetItem>
#include <QGroupBox>
#include <QLineEdit>
#include <QMessageBox>

#include "ARsql.h"

#include "ARDialogCAP.h"

ARDialogCAP::ARDialogCAP(QWidget *parent) : QDialog(parent)
 {
 	num_col=4;
 	sql = new ARsql(this);
	setWindowTitle(tr("Cerca C.A.P."));
	infobox = new QMessageBox(tr("Informazioni"),"",QMessageBox::Question,0,0,0,this);

	cornice = new QGroupBox(tr("Ricerca "),this); cornice->setGeometry( 1,190,353,110);
  _cap   = new QLabel(tr("C.A.P."),cornice);    _cap->setGeometry   ( 8, 15, 80, 24);
  cap    = new QLineEdit(cornice);              cap->setGeometry    (60, 15, 80, 24);
  _citta = new QLabel(tr("Citt"),cornice);     _citta->setGeometry ( 8, 45, 80, 24);
  citta  = new QLineEdit(cornice);              citta->setGeometry  (60, 45,285, 24);
  _prov  = new QLabel(tr("Provincia"),cornice); _prov->setGeometry  ( 8, 75, 80, 24);
  prov   = new QLineEdit(cornice);              prov->setGeometry   (60, 75, 50, 24);
  prov->setMaxLength(2);
  citta->setMaxLength(255);
  cap->setMaxLength(5);

  table = new QTableWidget(this);
  table->setGeometry(0,0,450,190);
  table->setSortingEnabled(true);
  table->setAlternatingRowColors(true);
  table->setEditTriggers(QAbstractItemView::NoEditTriggers);
  table->setSelectionMode(QAbstractItemView::SingleSelection);
  table->setSelectionBehavior(QAbstractItemView::SelectRows);
 	for(int i=0;i<num_col;i++) table->insertColumn(i);
 	table->setColumnWidth(0,20);
 	table->setColumnWidth(1,50);
 	table->setColumnWidth(2,260);
 	table->setColumnWidth(3,60);
 	table->setHorizontalHeaderLabels(QStringList() << "ID" << "C.A.P." << "Citt" << "Provincia");
  table->hideColumn(0);

 	dummy = new QPushButton("",cornice);
  dummy->setGeometry(255,84,96,24);
 	inserisci = new QPushButton(QIcon("pic/ok.png"),tr("Inserisci"),this);
 	inserisci->setGeometry(355,198,96,50);
 	annulla = new QPushButton(QIcon("pic/exit.png"),tr("Annulla"),this);
  annulla->setGeometry(355,248,96,50);
 	reset = new QPushButton(QIcon("pic/no_search.png"),tr("Azzera"),cornice);
  reset->setGeometry(159,84,96,24);
 	search = new QPushButton(QIcon("pic/search.png"),tr("Cerca"),cornice);
  search->setGeometry(255,84,96,24);

  connect(annulla,SIGNAL(clicked()),this,SLOT(reject()));
  connect(inserisci,SIGNAL(clicked()),this,SLOT(inserisciCAP()));
  connect(citta,SIGNAL(returnPressed()),this,SLOT(visCAP()));
  connect(prov,SIGNAL(returnPressed()),this,SLOT(visCAP()));
  connect(cap,SIGNAL(returnPressed()),this,SLOT(visCAP()));
  connect(search,SIGNAL(clicked()),this,SLOT(visCAP()));
  connect(reset,SIGNAL(clicked()),this,SLOT(resRicerca()));

  infobox->setWindowModality(Qt::WindowModal);

  setWindowFlags(Qt::Window | Qt::MSWindowsFixedSizeDialogHint | Qt::WindowTitleHint | Qt::WindowSystemMenuHint);
  setGeometry(200,200,450,300);
 }


void ARDialogCAP::inserisciCAP()
 {
 	if(table->currentRow()>=0) accept();
 	else
 	 {
 	 	infobox->setText(tr("Nessun elemento selezionato!"));
 	  infobox->exec();
 	 }
 }

void ARDialogCAP::visCAP()
 {
 	MYSQL_RES *rs=NULL;
 	MYSQL_ROW row;
 	QString query,cap,citta,prov;
 	bool primo;
 	int r;
 	
 	table->setRowCount(0);
 	r=0; primo=true;
 	cap = quote(this->cap->text(),true);
 	citta= quote(this->citta->text(),true);
 	prov = quote(this->prov->text(),true);
 	if(cap!="" || citta!="" || prov!="")
 	 {
 	 	query="SELECT * FROM cap";
 	  if(cap!="")   { if(primo) { query+=" WHERE cap LIKE '%"+cap+"%'"; primo=false; }        else { query+=" AND cap LIKE '%"+cap+"%'"; } }
 	  if(citta!="") { if(primo) { query+=" WHERE citta LIKE '%"+citta+"%'"; primo=false; }    else { query+=" AND citta LIKE '%"+citta+"%'"; } }
 	  if(prov!="")  { if(primo) { query+=" WHERE provincia LIKE '%"+prov+"%'"; primo=false; } else { query+=" AND provincia LIKE '%"+prov+"%'"; } }
 	  query+=" ORDER BY citta";
 	  rs=sql->doQueryRS(query);
 	 }

 	if(rs)
 	 {
 	  while((row=mysql_fetch_row(rs)))
     {
   	  table->insertRow(r); table->setRowHeight(r,18);
   	  table->setItem(r,0,inserisciRiga(row[0]));
   	  table->setItem(r,1,inserisciRiga(row[2]));
   	  table->setItem(r,2,inserisciRiga(row[1]));
   	  table->setItem(r,3,inserisciRiga(row[3]));
   	  r++;
     }
    mysql_free_result(rs);
    if(r==0) 
     {
     	//if(infobox->isHidden())
     	 {
     	  //infobox->setText(tr("Nessun fornitore trovato!"));
 	      //infobox->exec();
 	     }
     }
   }
 }

QTableWidgetItem *ARDialogCAP::inserisciRiga(QString str)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	return item;
 }

QTableWidgetItem *ARDialogCAP::inserisciRiga(const char *str)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	return item;
 }

QString ARDialogCAP::getCAP() { return table->item(table->currentRow(),1)->text(); }

QString ARDialogCAP::getCitta() { return table->item(table->currentRow(),2)->text();; }

QString ARDialogCAP::getProvincia() { return table->item(table->currentRow(),3)->text(); }

void ARDialogCAP::resRicerca()
 {
 	cap->setText("");
 	citta->setText("");
 	prov->setText("");
 	visCAP();
 }

QString ARDialogCAP::quote(QString str, bool like)
 {
 	if(like)
 	 {
 	  str.replace('\\',"\\\\\\\\");
 	  str.replace('\'',"\\'");
 	 }
 	else
   {
 	  str.replace('\\',"\\\\");
 	  str.replace('\'',"\\'");
   }
 	return str;
 }
