#ifndef ARDIALOGPREF_H
#define ARDIALOGPREF_H

#include <QDialog>

class QPushButton;
class QLineEdit;
class QCheckBox;
class QLabel;
class QString;
class QTabWidget;
class QMessageBox;
class QFileDialog;

class ARsql;

class ARDialogPref : public QDialog
 {
  Q_OBJECT

  public:
   QPushButton *salva,*annulla;
   
   ARDialogPref(QWidget *parent = 0);

  public slots:
   void loadPref();
   void savePref();
   void sfogliaDirBackPath();
   void sfogliaDirMysqlPath();
   void sfogliaDirDataPath();
   void sfogliaDirDbPath();
   void attivaTab(int);

  private:
   ARsql *sql;
   QTabWidget *tab;
   QWidget *tpage1,*tpage2,*tpage3;
   int current_tab;
   // Backup
   QPushButton *backpathb,*mysqlpathb,*datapathb,*dbpathb;
   QLabel *_backpath,*_mysqlpath,*_datapath,*_dbpath,*_msg;
   QLineEdit *backpath,*mysqlpath,*datapath,*dbpath;
   // Cambio password
   QLabel *_oldpwd,*_newpwd,*_verpwd;
   QLineEdit *oldpwd,*newpwd,*verpwd;
   QMessageBox *warnbox;
   // Varie
   QCheckBox *ckprev;

   bool checkFormBak();
   bool checkFormPwd();
   QString quote(QString,bool like = false);
   
  private slots:
   void cambiaTab(int);
 };

#endif
