#include <QPushButton>
#include <QLineEdit>
#include <QTextEdit>
#include <QLabel>
#include <QString>
#include <QDate>

#include "ARsql.h"

#include "ARDialogScadenza.h"

ARDialogScadenza::ARDialogScadenza(QWidget *parent) : QDialog(parent)
 {
  sql = new ARsql(this);

  b_ignora=b_ignoratutti=b_pagato=false;
  _descrizione = new QLabel("",this);           _descrizione->setGeometry( 10, 10,450, 42);
  _descrizione->setWordWrap(true);
  _somma = new QLabel("Somma scadenza:",this);  _somma->setGeometry      ( 10, 60,450, 24);
  somma  = new QLabel("",this);                 somma->setGeometry       (100, 60,450, 24);
  _datas = new QLabel("Scadenza il:",this);     _datas->setGeometry      ( 10, 90,450, 24);
  datas  = new QLabel("",this);                 datas->setGeometry       (100, 90,450, 24);
  _note  = new QLabel(tr("Note:"),this);        _note->setGeometry       ( 10,120,450, 24);
  note   = new QTextEdit("",this);              note->setGeometry        ( 10,140,450,100);
  note->setReadOnly(true);
 	
  paga = new QPushButton(QIcon("pic/pay.png"),tr("Segna come pagata"),this);
  paga->setGeometry(10,250,140,30);
  ignora = new QPushButton(QIcon("pic/exit.png"),tr("Ignora scadenza"),this);
  ignora->setGeometry(160,250,140,30);
  ignoratutto = new QPushButton(QIcon("pic/exit.png"),tr("Ignora tutte le scadenze"),this);
  ignoratutto->setGeometry(310,250,150,30);
  
  connect(ignora,SIGNAL(clicked()),this,SLOT(ignoraUno()));
  connect(ignoratutto,SIGNAL(clicked()),this,SLOT(ignoraTutti()));
  connect(paga,SIGNAL(clicked()),this,SLOT(settaPagato()));

  setWindowFlags(Qt::Window | Qt::MSWindowsFixedSizeDialogHint | Qt::WindowTitleHint | Qt::WindowSystemMenuHint);
  setGeometry(100,200,470,290);
 }

void ARDialogScadenza::settaInfo(QString art,QString descr,QString misura,QString articoloID,QString fornitoreID,QString data)
 {
  QString zeri,fornitore;
  QDate d = QDate::fromString(data,"yyyy-MM-dd");
  MYSQL_RES *rs;
  MYSQL_ROW row;

  rs=sql->doQueryRS("SELECT nome FROM fornitori WHERE fornitoreID='"+fornitoreID+"'"); 	
  if(rs)
   {
    if(mysql_num_rows(rs)!=1) fornitore="SCONOSCIUTO";
    else { row=mysql_fetch_row(rs); fornitore=row[0]; }
    mysql_free_result(rs);
   }
  for(int i=0;i<10-articoloID.length();i++) zeri+="0";
  setWindowTitle(tr("Scarica articolo: ")+zeri+articoloID);
  this->info->setText("- Articolo:<br>&nbsp;&nbsp;&nbsp;<b>("+art+") "+descr+" ["+misura+"]</b><br><br>- Fornitore:<br>&nbsp;&nbsp;&nbsp;<b>"+fornitore+"</b><br><br>L'articolo risulta caricato in magazzino <b>"+d.toString("dddd, dd MMM yyyy")+"</b>");
 }

void ARDialogScadenza::ignoraUno()   { b_ignora=true; b_ignoratutti=false; b_pagato=false; reject(); }

void ARDialogScadenza::ignoraTutti() { b_ignoratutti=true; b_ignora=false; b_pagato=false; reject(); }

void ARDialogScadenza::settaPagato() { b_pagato=true; b_ignoratutti=false; b_ignora=false; reject(); }

bool ARDialogScadenza::isIgnora() { return b_ignora; }

bool ARDialogScadenza::isIgnoraTutti() { return b_ignoratutti; }

bool ARDialogScadenza::isPagato() { return b_pagato; }

void ARDialogScadenza::setSomma(QString som) { somma->setText("<font size=+2>"+som+" Euro</font>"); }

void ARDialogScadenza::setData(QString dat)
 {
  int n;
  QString manca,aux;
  QDate da = QDate::fromString(dat,"yyyy-MM-dd");
  QDate og = QDate::currentDate();

  n=og.daysTo(da);
  if(n>1)   manca=" (tra "+aux.sprintf("%d",n)+" giorni)";
  if(n==1)  manca=" (tra "+aux.sprintf("%d",n)+" giorno)";
  if(n==0)  manca="<font color=#ff0000>(scade oggi)</font>";
  if(n<0)   manca="<font color=#ff0000>(scaduta da "+aux.sprintf("%d",-n)+" giorni)</font>";
  if(n==-1) manca="<font color=#ff0000>(scaduta da "+aux.sprintf("%d",-n)+" giorno)</font>";
  datas->setText("<font size=+2>"+da.toString("dd MMMM yyyy")+" "+manca+"</font>");
 }

void ARDialogScadenza::setNote(QString no) { note->clear(); note->insertPlainText(no); }

void ARDialogScadenza::setScadenzaID(QString scadID) { scadenzaID=scadID; }

void ARDialogScadenza::setDescrizione(QString des) { _descrizione->setText(des); }
