#ifndef ARDIALOGSERVIZI_H
#define ARDIALOGSERVIZI_H

#include <QDialog>

class QPushButton;
class QGroupBox;
class QLabel;
class QLineEdit;
class QHeaderView;
class QTableWidget;
class QTableWidgetItem;
class QMessageBox;
class QTextEdit;

class ARFinestra;
class ARFattura;
class ARsql;

class ARDialogServizi : public QDialog
 {
  Q_OBJECT

  public:
   bool dettagli;
   QGroupBox *cornice;
   QPushButton *dummy,*add,*addsel,*esci,*search,*reset;
   QLineEdit *causale,*aspetto,*colli,*peso;
   QTableWidget *table,*vettore;
   QTextEdit *note;
   
   ARDialogServizi(QWidget *parent = 0);
   bool populateFor(QString);
   QString getElemento(int,int,QString def="");
   void setDestTable(QTableWidget *);
   QString getBollaID();
   QString getPrintBollaID();
   QString getFornitoreID();
   void setBollaID(QString);
   void setPrintBollaID(QString);
   void setFornitoreID(QString);
   void setMsg(QString);
   void settaPadre(ARFattura *);

  public slots:
   void resRicerca();
   void visServizi();
   void addAll();
   void addSelection();

  private:
   QString printBollaID,bollaID,fornitoreID;
   ARFinestra *mainWin;
   ARFattura *padre;
   QMessageBox *infobox,*warnbox,*yesnobox;
   ARsql *sql;
   QLabel *_msg,*_table,*_articolo,*_descrizione,*_prezzo,*_iva;
   QLineEdit *articolo,*descrizione,*prezzo,*iva;
   QTableWidget *desttable;
   int num_col;

   QString quote(QString, bool like = false);
   QTableWidgetItem *inserisciRiga(const char *, int alig=Qt::AlignLeft);
   QTableWidgetItem *inserisciRiga(QString, int alig=Qt::AlignLeft);
 };

#endif
