#include <QPushButton>
#include <QLineEdit>
#include <QComboBox>
#include <QCheckBox>
#include <QLabel>
#include <QString>
#include <QTabWidget>
#include <QMessageBox>

#include "ARsql.h"

#include "ARDialogStampe.h"

ARDialogStampe::ARDialogStampe(QWidget *parent) : QDialog(parent)
 {
 	sql = new ARsql(this);

  warnbox = new QMessageBox(tr("Avviso"),"",QMessageBox::Warning,0,0,0,this);
  warnbox->setWindowModality(Qt::WindowModal);

  tpage1 = new QWidget(this);
  tpage2 = new QWidget(this);
  tpage3 = new QWidget(this);
  tab = new QTabWidget(this); tab->setGeometry(5,5,540,405);
  tab->addTab(tpage1,QIcon("pic/etichetta.png"),tr("Etichette"));
  tab->addTab(tpage2,QIcon("pic/intestazione.png"),tr("Intestazioni"));
  tab->addTab(tpage3,QIcon("pic/tabulati.png"),tr("Tabulati"));
  current_tab=0;

  // Etichette  
  _mmdestra   = new QLabel(tr("Margine destro (mm)"),tpage1);      _mmdestra->setGeometry  ( 10, 10,150,24);
  mmdestra    = new QLineEdit("",tpage1);                          mmdestra->setGeometry   (110, 10, 60,24);
  mmdestra->setValidator(new QIntValidator(-100000,100000,mmdestra));
  _mmalto     = new QLabel(tr("Margine alto (mm)"),tpage1);        _mmalto->setGeometry    (180, 10,150,24);
  mmalto      = new QLineEdit("",tpage1);                          mmalto->setGeometry     (280, 10, 60,24);
  mmalto->setValidator(new QIntValidator(-100000,100000,mmalto));
  _mroriz     = new QLabel(tr("Rientro orizzontale (mm)"),tpage1); _mroriz->setGeometry    (350, 10,150,24);
  mroriz      = new QLineEdit("",tpage1);                          mroriz->setGeometry     (470, 10, 60,24);
  mroriz->setValidator(new QIntValidator(-100000,100000,mroriz));
  _mmsinistra = new QLabel(tr("Margine sinistro (mm)"),tpage1);    _mmsinistra->setGeometry( 10, 40,150,24);
  mmsinistra  = new QLineEdit("",tpage1);                          mmsinistra->setGeometry (110, 40, 60,24);
  mmsinistra->setValidator(new QIntValidator(-100000,100000,mmsinistra));
  _mmbasso    = new QLabel(tr("Margine basso (mm)"),tpage1);       _mmbasso->setGeometry   (180, 40,150,24);
  mmbasso     = new QLineEdit("",tpage1);                          mmbasso->setGeometry    (280, 40, 60,24);
  mmbasso->setValidator(new QIntValidator(-100000,100000,mmbasso));
  _mrvert     = new QLabel(tr("Rientro verticale (mm)"),tpage1);   _mrvert->setGeometry    (350, 40,150,24);
  mrvert      = new QLineEdit("",tpage1);                          mrvert->setGeometry     (470, 40, 60,24);
  mrvert->setValidator(new QIntValidator(-100000,100000,mrvert));
  _numr = new QLabel(tr("Numero etichette per colonna"),tpage1);   _numr->setGeometry      ( 10, 70,200,24);
  numr  = new QLineEdit("",tpage1);                                numr->setGeometry       (160, 70, 40,24);
  numr->setValidator(new QIntValidator(0,100,numr));
  _numc = new QLabel(tr("Numero etichette per righa"),tpage1);     _numc->setGeometry      ( 10,100,200,24);
  numc  = new QLineEdit("",tpage1);                                numc->setGeometry       (160,100, 40,24);
  numc->setValidator(new QIntValidator(0,100,numc));
  _dimBC = new QLabel(tr("Dimensioni codice a barre"),tpage1);   _dimBC->setGeometry     ( 10,130,200,24);
  listaDimBC = new QComboBox(tpage1);                            listaDimBC->setGeometry (160,130, 80,24);
  listaDimBC->addItem(tr("Grande"),QVariant(0));
  listaDimBC->addItem(tr("Piccolo"),QVariant(1));
  _altBC = new QLabel(tr("Altezza codice a barre"),tpage1);      _altBC->setGeometry     ( 10,160,200,24);
  listaAltBC = new QComboBox(tpage1);                            listaAltBC->setGeometry (160,160, 80,24);
  listaAltBC->addItem(tr("Massima"),QVariant(60));
  listaAltBC->addItem(tr("Media"),QVariant(48));
  listaAltBC->addItem(tr("Minima"),QVariant(36));
  ckart      = new QCheckBox("Includi articolo",tpage1); ckart->setGeometry     (10,190,200,24);
  ckcolore   = new QCheckBox("Includi colore",tpage1);   ckcolore->setGeometry  (10,220,200,24);
  ckfondo    = new QCheckBox("Includi fondo",tpage1);    ckfondo->setGeometry   (10,250,200,24);
  cktacco    = new QCheckBox("Includi tacco",tpage1);    cktacco->setGeometry   (10,280,200,24);
  ckstagione = new QCheckBox("Includi stagione",tpage1); ckstagione->setGeometry(10,310,200,24);
  
  // Intestazioni
  _mmdestra1   = new QLabel(tr("Margine destro (mm)"),tpage2);      _mmdestra1->setGeometry  ( 10, 10,150,24);
  mmdestra1    = new QLineEdit("",tpage2);                          mmdestra1->setGeometry   (110, 10, 60,24);
  mmdestra1->setValidator(new QIntValidator(-100000,100000,mmdestra1));
  _mmalto1     = new QLabel(tr("Margine alto (mm)"),tpage2);        _mmalto1->setGeometry    (180, 10,150,24);
  mmalto1      = new QLineEdit("",tpage2);                          mmalto1->setGeometry     (280, 10, 60,24);
  mmalto1->setValidator(new QIntValidator(-100000,100000,mmalto1));
  _mroriz1     = new QLabel(tr("Rientro orizzontale (mm)"),tpage2); _mroriz1->setGeometry    (350, 10,150,24);
  mroriz1      = new QLineEdit("",tpage2);                          mroriz1->setGeometry     (470, 10, 60,24);
  mroriz1->setValidator(new QIntValidator(-100000,100000,mroriz1));
  _mmsinistra1 = new QLabel(tr("Margine sinistro (mm)"),tpage2);   _mmsinistra1->setGeometry( 10, 40,150,24);
  mmsinistra1  = new QLineEdit("",tpage2);                          mmsinistra1->setGeometry (110, 40, 60,24);
  mmsinistra1->setValidator(new QIntValidator(-100000,100000,mmsinistra1));
  _mmbasso1    = new QLabel(tr("Margine basso (mm)"),tpage2);      _mmbasso1->setGeometry   (180, 40,150,24);
  mmbasso1     = new QLineEdit("",tpage2);                          mmbasso1->setGeometry    (280, 40, 60,24);
  mmbasso1->setValidator(new QIntValidator(-100000,100000,mmbasso1));
  _mrvert1     = new QLabel(tr("Rientro verticale (mm)"),tpage2);  _mrvert1->setGeometry    (350, 40,150,24);
  mrvert1      = new QLineEdit("",tpage2);                         mrvert1->setGeometry     (470, 40, 60,24);
  mrvert1->setValidator(new QIntValidator(-100000,100000,mrvert1));
  _numr1 = new QLabel(tr("Numero etichette per colonna"),tpage2); _numr1->setGeometry      ( 10, 70,200,24);
  numr1  = new QLineEdit("",tpage2);                              numr1->setGeometry       (160, 70, 40,24);
  numr1->setValidator(new QIntValidator(0,100,numr));
  _numc1 = new QLabel(tr("Numero etichette per righa"),tpage2);   _numc1->setGeometry      ( 10,100,200,24);
  numc1  = new QLineEdit("",tpage2);                              numc1->setGeometry       (160,100, 40,24);
  numc1->setValidator(new QIntValidator(0,100,numc1));
  _titcli = new QLabel(tr("Titolo per clienti"),tpage2);          _titcli->setGeometry     ( 10,130,200,24);
  titcli  = new QLineEdit("",tpage2);                             titcli->setGeometry      (110,130, 90,24);
  titcli->setMaxLength(30);
  _titfor = new QLabel(tr("Titolo per fornitori"),tpage2);        _titfor->setGeometry     ( 10,160,200,24);
  titfor  = new QLineEdit("",tpage2);                             titfor->setGeometry      (110,160, 90,24);
  titfor->setMaxLength(30);
  
 	salva = new QPushButton(QIcon("pic/floppy.png"),tr("Salva impostazioni"),this);
  salva->setGeometry(5,415,120,30);
 	annulla = new QPushButton(QIcon("pic/exit.png"),tr("Chiudi"),this);
  annulla->setGeometry(135,415,120,30);
  connect(annulla,SIGNAL(clicked()),this,SLOT(reject()));
  connect(salva,SIGNAL(clicked()),this,SLOT(savePrefStampa()));
  connect(tab,SIGNAL(currentChanged(int)),this,SLOT(cambiaTab(int)));

  setWindowFlags(Qt::Window | Qt::MSWindowsFixedSizeDialogHint | Qt::WindowTitleHint | Qt::WindowSystemMenuHint);
  setWindowTitle(tr("Impostazioni per le stampe"));
  setGeometry(200,200,550,450);
 }

void ARDialogStampe::loadPrefStampa()
 {
 	uint c_vis;
 	
 	// Etichette
  mmdestra->setText(sql->getPref(1,"pref_stampante_et"));
  mmalto->setText(sql->getPref(2,"pref_stampante_et"));
  mroriz->setText(sql->getPref(3,"pref_stampante_et"));
  mmsinistra->setText(sql->getPref(4,"pref_stampante_et"));
  mmbasso->setText(sql->getPref(5,"pref_stampante_et"));
  mrvert->setText(sql->getPref(6,"pref_stampante_et"));
  numr->setText(sql->getPref(7,"pref_stampante_et"));
  numc->setText(sql->getPref(8,"pref_stampante_et"));
  if(sql->getPref(10,"pref_stampante_et")=="0") listaDimBC->setCurrentIndex(0);
  else listaDimBC->setCurrentIndex(1);
  if(sql->getPref(11,"pref_stampante_et")=="60") listaAltBC->setCurrentIndex(0);
  if(sql->getPref(11,"pref_stampante_et")=="48") listaAltBC->setCurrentIndex(1);
  if(sql->getPref(11,"pref_stampante_et")=="36") listaAltBC->setCurrentIndex(2);
  c_vis=sql->getPref(12,"pref_stampante_et").toUInt();
  if(c_vis & 1)  ckart->setCheckState(Qt::Checked);      else ckart->setCheckState(Qt::Unchecked);
  if(c_vis & 2)  ckcolore->setCheckState(Qt::Checked);   else ckcolore->setCheckState(Qt::Unchecked);
  if(c_vis & 4)  ckfondo->setCheckState(Qt::Checked);    else ckfondo->setCheckState(Qt::Unchecked);
  if(c_vis & 8)  cktacco->setCheckState(Qt::Checked);    else cktacco->setCheckState(Qt::Unchecked);
  if(c_vis & 16) ckstagione->setCheckState(Qt::Checked); else ckstagione->setCheckState(Qt::Unchecked); 
  // Intestazioni
  mmdestra1->setText(sql->getPref(1,"pref_stampante_in"));
  mmalto1->setText(sql->getPref(2,"pref_stampante_in"));
  mroriz1->setText(sql->getPref(3,"pref_stampante_in"));
  mmsinistra1->setText(sql->getPref(4,"pref_stampante_in"));
  mmbasso1->setText(sql->getPref(5,"pref_stampante_in"));
  mrvert1->setText(sql->getPref(6,"pref_stampante_in"));
  numr1->setText(sql->getPref(7,"pref_stampante_in"));
  numc1->setText(sql->getPref(8,"pref_stampante_in"));
  titcli->setText(sql->getPref(9,"pref_stampante_in"));
  titfor->setText(sql->getPref(10,"pref_stampante_in"));
 }

void ARDialogStampe::savePrefStampa()
 {
 	QString m_destro,m_alto,r_oriz,m_sinistro,m_basso,r_vert,num_r,num_c,bcodesmall,bcodealt,campi_vis;
 	QString title_cli,title_for;
 	int c_vis=0;
 	
 	if(current_tab==0) // Etichette
 	 {
 	 	if(!checkFormEt())
 	 	 {
 	    m_destro=mmdestra->text();
 	    m_alto=mmalto->text();
 	    r_oriz=mroriz->text();
      m_sinistro=mmsinistra->text();
      m_basso=mmbasso->text();
      r_vert=mrvert->text();
      num_r=numr->text();
      num_c=numc->text();
      bcodesmall=listaDimBC->itemData(listaDimBC->currentIndex()).toString();
      bcodealt=listaAltBC->itemData(listaAltBC->currentIndex()).toString();
      if(ckart->checkState()==Qt::Checked)      c_vis+=1;
      if(ckcolore->checkState()==Qt::Checked)   c_vis+=2;
      if(ckfondo->checkState()==Qt::Checked)    c_vis+=4;
      if(cktacco->checkState()==Qt::Checked)    c_vis+=8;
      if(ckstagione->checkState()==Qt::Checked) c_vis+=16;
      campi_vis.sprintf("%d",c_vis);
      if(sql->doQuery("UPDATE pref_stampante_et SET m_destro='"+m_destro+"', m_alto='"+m_alto+"', r_oriz='"+r_oriz+"', m_sinistro='"+m_sinistro+"', m_basso='"+m_basso+"', r_vert='"+r_vert+"', num_r='"+num_r+"', num_c='"+num_c+"', bcodesmall='"+bcodesmall+"', bcodealt='"+bcodealt+"', campi_vis='"+campi_vis+"'"))
       {
        warnbox->setText(tr("Impostazioni di stampa per etichette salvate!"));
        warnbox->exec();
       }
     }
   }
 	if(current_tab==1)
 	 {
 	 	if(!checkFormIn()) // Intestazioni
 	 	 {
 	    m_destro=mmdestra1->text();
 	    m_alto=mmalto1->text();
 	    r_oriz=mroriz1->text();
      m_sinistro=mmsinistra1->text();
      m_basso=mmbasso1->text();
      r_vert=mrvert1->text();
      num_r=numr1->text();
      num_c=numc1->text();
      title_cli=quote(titcli->text());
      title_for=quote(titfor->text());
      if(sql->doQuery("UPDATE pref_stampante_in SET m_destro='"+m_destro+"', m_alto='"+m_alto+"', r_oriz='"+r_oriz+"', m_sinistro='"+m_sinistro+"', m_basso='"+m_basso+"', r_vert='"+r_vert+"', num_r='"+num_r+"', num_c='"+num_c+"', title_cli='"+title_cli+"', title_for='"+title_for+"'"))
       {
        warnbox->setText(tr("Impostazioni di stampa per le intestazioni salvate!"));
        warnbox->exec();
       }
     }
   }
 }

bool ARDialogStampe::checkFormEt()
 {
 	if(quote(mmdestra->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire il margine destro!"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(mmalto->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire il margine alto!"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(mmsinistra->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire il margine sinistro!"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(mmbasso->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire il margine basso!"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(numr->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire il numero di etichette per colonna!"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(numc->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire il numero di etichette per righa!"));
 	  warnbox->exec();
 	  return true;
 	 }
 	return false;
 }

bool ARDialogStampe::checkFormIn()
 {
 	if(quote(mmdestra1->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire il margine destro!"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(mmalto1->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire il margine alto!"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(mmsinistra1->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire il margine sinistro!"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(mmbasso1->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire il margine basso!"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(numr1->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire il numero di etichette per colonna!"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(numc1->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire il numero di etichette per righa!"));
 	  warnbox->exec();
 	  return true;
 	 }
 	return false;
 }

void ARDialogStampe::cambiaTab(int n) {	current_tab=n; }

void ARDialogStampe::attivaTab(int n) {	tab->setCurrentIndex(n); }

QString ARDialogStampe::quote(QString str, bool like)
 {
 	if(like)
 	 {
 	  str.replace('\\',"\\\\\\\\");
 	  str.replace('\'',"\\'");
 	 }
 	else
   {
 	  str.replace('\\',"\\\\");
 	  str.replace('\'',"\\'");
   }
 	return str;
 }
