#include <QPushButton>
#include <QGroupBox>
#include <QLabel>
#include <QLineEdit>
#include <QMessageBox>
#include <QRegExp>
#include <QTableWidget>
#include <QTableWidgetItem>

#include "ARsql.h"
#include "ARFinestra.h"
#include "ARDialogIndirReso.h"
#include "ARDialogProv.h"
#include "ARDialogCAP.h"

#include "ARFornitore.h"

ARFornitore::ARFornitore(QWidget *parent) : QWidget(parent)
 {
  num_col=7;
  mainWin=(ARFinestra *)parent;
  indresobox = new ARDialogIndirReso(parent);
  sql = new ARsql(this);
  provbox  = new ARDialogProv(this);
  capbox   = new ARDialogCAP(this);
  yesnobox = new QMessageBox(tr("Scegli"),"",QMessageBox::Question,QMessageBox::Yes,QMessageBox::No,QMessageBox::NoButton,this);
  infobox  = new QMessageBox(tr("Informazioni"),"",QMessageBox::Question,0,0,0,this);
  warnbox  = new QMessageBox(tr("Avviso"),"",QMessageBox::Warning,0,0,0,this);
  cornice  = new QGroupBox(tr("Inserisci nuovo fornitore "),this);
  cornice->setGeometry(2,0,650,420);

  _nome  = new QLabel(tr("Nome"),this);              _nome->setGeometry (10,   20,  80, 24);
  nome   = new QLineEdit("",this);                   nome->setGeometry  (80,   20, 290, 24);
  _etich = new QLabel(tr("Nome su etichetta"),this); _etich->setGeometry(380,  20, 120, 24);
  etich  = new QLineEdit("",this);                   etich->setGeometry (475,  20, 155, 24);
  _indr  = new QLabel(tr("Indirizzo"),this);         _indr->setGeometry (10,   50,  80, 24);
  indr   = new QLineEdit("",this);                   indr->setGeometry  (80,   50, 550, 24);
  _cap   = new QLabel(tr("C.A.P."),this);            _cap->setGeometry  (10,   80,  80, 24);
  cap    = new QLineEdit("",this);                   cap->setGeometry   (80,   80,  42, 24);
  cercap = new QPushButton(QIcon("pic/cerca.png"),"",this);
  cercap->setGeometry(126,80,24,24);
  _citta = new QLabel(tr("Citt"),this);             _citta->setGeometry(155,  80,  80, 24);
  citta  = new QLineEdit("",this);                   citta->setGeometry (185,  80, 310, 24);
  _prov  = new QLabel(tr("Provincia"),this);         _prov->setGeometry (505,  80,  80, 24);
   prov  = new QLineEdit("",this);                   prov->setGeometry  (560,  80,  42, 24);
  cercapr = new QPushButton(QIcon("pic/cerca.png"),"",this);
  cercapr->setGeometry  (606,80,24,24);
  _nazio = new QLabel(tr("Nazione"),this);           _nazio->setGeometry( 10, 110,  80, 24);
  nazio  = new QLineEdit(tr("Italia"),this);         nazio->setGeometry ( 80, 110, 550, 24);
  _tel   = new QLabel(tr("Telefono"),this);          _tel->setGeometry  ( 10, 140,  80, 24);
  tel    = new QLineEdit("",this);                   tel->setGeometry   ( 80, 140, 150, 24);
  _fax   = new QLabel(tr("Fax"),this);               _fax->setGeometry  (240, 140,  80, 24);
  fax    = new QLineEdit("",this);                   fax->setGeometry   (270, 140, 150, 24);
  _cell  = new QLabel(tr("Cellulare"),this);         _cell->setGeometry (430, 140,  80, 24);
  cell   = new QLineEdit("",this);                   cell->setGeometry  (480, 140, 150, 24);
  _piva  = new QLabel(tr("Partita IVA"),this);       _piva->setGeometry ( 10, 170,  80, 24);
  piva   = new QLineEdit("",this);                   piva->setGeometry  ( 80, 170, 230, 24);
  _cf    = new QLabel(tr("Codice fiscale"),this);    _cf->setGeometry   (320, 170,  80, 24);
  cf     = new QLineEdit("",this);                   cf->setGeometry    (400, 170, 230, 24);
  _datibanca = new QLabel(tr("<b>Dati bancari:</b>"),this); _datibanca->setGeometry(  6, 200,  80, 24);
  _banca = new QLabel(tr("Denominazione banca"),this); _banca->setGeometry( 10, 230, 150, 24);
  banca  = new QLineEdit("",this);                     banca->setGeometry (130, 230, 500, 24);
  _abi   = new QLabel(tr("ABI"),this);                 _abi->setGeometry  ( 10, 260,  80, 24);
  abi    = new QLineEdit("",this);                     abi->setGeometry   ( 40, 260, 100, 24);
  _cab   = new QLabel(tr("CAB"),this);                 _cab->setGeometry  (150, 260,  80, 24);
  cab    = new QLineEdit("",this);                     cab->setGeometry   (180, 260, 100, 24);
  _cin   = new QLabel(tr("CIN"),this);                 _cin->setGeometry  (290, 260,  80, 24);
  cin    = new QLineEdit("",this);                     cin->setGeometry   (320, 260, 100, 24);
  _cc    = new QLabel(tr("Numero C.C."),this);        _cc->setGeometry    (430, 260,  80, 24);
   cc    = new QLineEdit("",this);                     cc->setGeometry    (500, 260, 130, 24);
  _datiweb = new QLabel(tr("<b>Dati internet:</b>"),this); _datiweb->setGeometry(  6, 290,  80, 24);
  _email   = new QLabel(tr("Email"),this);                 _email->setGeometry  ( 10, 320, 150, 24);
  email    = new QLineEdit("",this);                        email->setGeometry  ( 80, 320, 550, 24);
  _sitoweb = new QLabel(tr("Sito web"),this);              _sitoweb->setGeometry( 10, 350, 150, 24);
  sitoweb  = new QLineEdit("",this);                        sitoweb->setGeometry( 80, 350, 550, 24);
  _indireso = new QLabel(tr("<b>Indirizzi per reso merce:</b>"),this); _indireso->setGeometry(  6, 380, 200, 24);
  nome->setMaxLength(255);
  etich->setMaxLength(255);
  indr->setMaxLength(255);
  cap->setMaxLength(5);
  citta->setMaxLength(255);
  prov->setMaxLength(2);
  nazio->setMaxLength(255);
  tel->setMaxLength(50);
  fax->setMaxLength(50);
  cell->setMaxLength(50);
  piva->setMaxLength(11);
  cf->setMaxLength(16);
  banca->setMaxLength(255);
  abi->setMaxLength(50);
  cab->setMaxLength(50);
  cin->setMaxLength(50);
  cc->setMaxLength(50);
  email->setMaxLength(255);
  sitoweb->setMaxLength(255);
  reg_email = new QRegExp("^[a-z0-9][_\\.a-z0-9-]+@([a-z0-9][0-9a-z-]+\\.)+([a-z]{2,4})$");
  tableindr = new QTableWidget(this);
  tableindr->setSortingEnabled(true);
  tableindr->setAlternatingRowColors(true);
  tableindr->setEditTriggers(QAbstractItemView::NoEditTriggers);
  tableindr->setSelectionMode(QAbstractItemView::SingleSelection);
  tableindr->setSelectionBehavior(QAbstractItemView::SelectRows);
  for(int i=0;i<num_col;i++) tableindr->insertColumn(i);
  tableindr->setColumnWidth(0,20); tableindr->hideColumn(0);
  tableindr->setColumnWidth(1,190);
  tableindr->setColumnWidth(2,80);
  tableindr->setColumnWidth(3,90);
  tableindr->setColumnWidth(4,90);
  tableindr->setColumnWidth(5,90);
  tableindr->setColumnWidth(6,90);
  tableindr->setHorizontalHeaderLabels(QStringList() << "ID" << "Indirizzo" << "Nazione" << "Tel." << "Fax" << "Cell." << "Email");
  tableindr->setGeometry(6,400,676,86);

  esegui = new QPushButton(QIcon("pic/fornitori_add.png"),tr("Inserisci"),this);
  esegui->setGeometry(543,393,106,24);
  addindr = new QPushButton(QIcon("pic/fornitori_add.png"),tr("Aggiungi indirizzo"),this);
  addindr->setGeometry(683,400,114,24);
  editindr = new QPushButton(QIcon("pic/edit.png"),tr("Visualizza indirizzo"),this);
  editindr->setGeometry(683,424,114,24);
  delindr = new QPushButton(QIcon("pic/delete.png"),tr("Cancella indirizzo"),this);
  delindr->setGeometry(683,448,114,24);

  connect(esegui,SIGNAL(clicked()),this,SLOT(addFornitore()));
  connect(addindr,SIGNAL(clicked()),this,SLOT(addIndirReso()));
  connect(delindr,SIGNAL(clicked()),this,SLOT(delIndirReso()));
  connect(editindr,SIGNAL(clicked()),this,SLOT(editIndirReso()));
  connect(cercapr,SIGNAL(clicked()),this,SLOT(cercaProvincia()));
  connect(cercap,SIGNAL(clicked()),this,SLOT(cercaCAP()));

  yesnobox->setWindowModality(Qt::WindowModal);
  yesnobox->setButtonText(QMessageBox::Yes,tr("Si"));
  yesnobox->setButtonText(QMessageBox::No,tr("No"));
  infobox->setWindowModality(Qt::WindowModal);
  warnbox->setWindowModality(Qt::WindowModal);
  setGeometry(0,61,800,490);
  azione=ARFORNITORE_ADD;  
  hide();
 }

void ARFornitore::cercaProvincia()
 {
 	provbox->clearForm();
 	if(provbox->exec()==QDialog::Accepted) prov->setText(provbox->getProvincia());
 }

void ARFornitore::cercaCAP()
 {
 	capbox->visCAP();
 	if(capbox->exec()==QDialog::Accepted)
 	 {
 	 	cap->setText(capbox->getCAP());
 	 	citta->setText(capbox->getCitta());
 	  prov->setText(capbox->getProvincia());
   }
 }

void ARFornitore::addFornitore()
 {
  QString nome=quote(this->nome->text());
  QString etich=quote(this->etich->text());
  QString indr=quote(this->indr->text());
  QString cap=quote(this->cap->text());
  QString citta=quote(this->citta->text());
  QString prov=quote(this->prov->text());
  QString nazio=quote(this->nazio->text());
  QString tel=quote(this->tel->text());
  QString fax=quote(this->fax->text());
  QString cell=quote(this->cell->text());
  QString piva=quote(this->piva->text());
  QString cf=quote(this->cf->text());
  QString banca=quote(this->banca->text());
  QString abi=quote(this->abi->text());
  QString cab=quote(this->cab->text());
  QString cin=quote(this->cin->text());
  QString cc=quote(this->cc->text());
  QString email=quote(this->email->text());
  QString sitoweb=quote(this->sitoweb->text());
  QString ts=sql->timeStamp();
  QString data=sql->data(ts);
  QString ora=sql->ora(ts);

 	if(isAzione(ARFORNITORE_ADD))
 	 {
 	  if(!checkForm())
 	   {
 	   	if(sql->doQuery("INSERT INTO fornitori VALUES('0','"+nome+"','"+etich+"','"+indr+"','"+cap+"','"+citta+"','"+prov+"','"+nazio+"','"+tel+"','"+fax+"','"+cell+"','"+piva+"','"+cf+"','"+banca+"','"+abi+"','"+cab+"','"+cin+"','"+cc+"','"+email+"','"+sitoweb+"','"+data+"','"+ora+"','"+ts+"')"))
       {
        infobox->setText(tr("Nuovo fornitore inserito"));
        infobox->exec();
        clearForm();
 	     }
 	   }
 	 }
 	if(isAzione(ARFORNITORE_EDIT))
 	 {
 	  if(!checkForm())
 	   {
 	    if(sql->doQuery("UPDATE fornitori SET nome='"+nome+"', etichetta='"+etich+"', indirizzo='"+indr+"', cap='"+cap+"', citta='"+citta+"', provincia='"+prov+"', nazione='"+nazio+"', tel='"+tel+"', fax='"+fax+"', cell='"+cell+"', piva='"+piva+"', cf='"+cf+"', banca='"+banca+"', abi='"+abi+"', cab='"+cab+"', cin='"+cin+"', cc='"+cc+"', email='"+email+"', sitoweb='"+sitoweb+"' WHERE fornitoreID='"+fornitoreID+"'"))
 	     {
        warnbox->setText(tr("Fornitore modificato e salvato!"));
        warnbox->exec(); 
        mainWin->visFornitori();
       }
     }
 	 }
 }

void ARFornitore::addIndirReso()
 {
  indresobox->clearForm();
  indresobox->setAzione(ARDIALOGINDIRRESO_ADD);
  indresobox->setWindowTitle(tr("Aggiungi indirizzo per reso merce"));
  indresobox->esegui->setText(tr("Aggiungi"));
  indresobox->esegui->setIcon(QIcon("pic/fornitori_add.png"));
  indresobox->setFornitoreID(fornitoreID);
  indresobox->exec();
 }

void ARFornitore::editIndirReso()
 {
  if(tableindr->currentRow()<0)
   {
    warnbox->setText(tr("Nessun indirizzo per il reso selezionato."));
    warnbox->exec();
   }
  else
   {
    QString indir_resoID;
    indir_resoID=tableindr->item(tableindr->currentRow(),0)->text();
    if(indresobox->setForm(indir_resoID))
     {
      indresobox->setAzione(ARDIALOGINDIRRESO_EDIT);
      indresobox->setWindowTitle(tr("Visualizza indirizzo per reso merce"));
      indresobox->esegui->setText(tr("Salva modifiche"));
      indresobox->esegui->setIcon(QIcon("pic/floppy.png"));
      indresobox->setIndirResoID(indir_resoID);
      indresobox->exec();
     }
    else
     {
      infobox->setText(tr("Indirizzo per il reso inesistente!"));
 	    infobox->exec();
     }
   }
 }

void ARFornitore::delIndirReso()
 {
  MYSQL_RES *rs;
  QString indir_resoID;

  if(tableindr->currentRow()<0)
   {
    warnbox->setText(tr("Nessun indirizzo per il reso selezionato."));
    warnbox->exec();
    return;
   }
  yesnobox->setText(tr("Vuoi veramente cancellare l'indirizzo per il reso?"));
  if(yesnobox->exec()==QMessageBox::No) return;
  indir_resoID=tableindr->item(tableindr->currentRow(),0)->text();
  rs=sql->doQueryRS("SELECT * FROM bolle WHERE indir_resoID='"+indir_resoID+"'");
  if(rs)
   {
    if(mysql_num_rows(rs)==0)
     {
   	  // Entro nella sezione critica
      mainWin->sql->connetti();
      if(!mainWin->sql->isBloccatoPer(sql->getDbName()+".bolle"))
       {
        warnbox->setText(tr("Un'altro utente sta occupando questo indirizzo per il reso,\nnon posso cancellare l'indirizzo per il reso adesso. Riprova pi tardi."));
 	      warnbox->exec();
        mainWin->sql->disconnetti();
        return;
       }
      mainWin->sql->disconnetti();
      sql->doQuery("DELETE FROM indirizzi_reso WHERE indir_resoID='"+indir_resoID+"'");
      infobox->setText(tr("Indirizzo per il reso cancellato!"));
      infobox->exec();
      visIndirReso();
     }
    else
     {
   	  warnbox->setText(tr("Non posso cancellare l'indirizzo per il reso poich\nsono presenti documenti di trasporto che lo usano."));
      warnbox->exec();
     }
    mysql_free_result(rs);
   }
 }

bool ARFornitore::setForm(QString fornitoreID)
 {
  MYSQL_RES *rs;
  MYSQL_ROW row;

  rs=sql->doQueryRS("SELECT * FROM fornitori WHERE fornitoreID='"+fornitoreID+"'");
  if(rs)
   {
    if(mysql_num_rows(rs)!=1) { mysql_free_result(rs); return false; }
    row=mysql_fetch_row(rs);
    nome->setFocus();
 	  nome->setText(row[1]);
 	  etich->setText(row[2]);
 	  indr->setText(row[3]);
 	  cap->setText(row[4]);
 	  citta->setText(row[5]);
 	  prov->setText(row[6]);
 	  nazio->setText(row[7]);
 	  tel->setText(row[8]);
 	  fax->setText(row[9]);
 	  cell->setText(row[10]);
 	  piva->setText(row[11]);
 	  cf->setText(row[12]);
 	  banca->setText(row[13]);
 	  abi->setText(row[14]);
 	  cab->setText(row[15]);
 	  cin->setText(row[16]);
 	  cc->setText(row[17]);
 	  email->setText(row[18]);
 	  sitoweb->setText(row[19]);
 	  mysql_free_result(rs);
 	  return true;
 	 }
 	return false;
 }

void ARFornitore::clearForm()
 {
 	nome->setFocus();
 	nome->clear();
 	etich->clear();
 	indr->clear();
 	cap->clear();
 	citta->clear();
 	prov->clear();
 	nazio->setText(tr("Italia"));
 	tel->clear();
 	fax->clear();
 	cell->clear();
 	piva->clear();
 	cf->clear();
 	banca->clear();
 	abi->clear();
 	cab->clear();
 	cin->clear();
 	cc->clear();
 	email->clear();
 	sitoweb->clear();
 }

bool ARFornitore::checkForm()
 {
 	if(quote(this->nome->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire il nome del fornitore"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(this->piva->text())=="" && quote(this->cf->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire la partita iva oppure il codice fiscale del fornitore"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(this->piva->text())!="" && quote(this->cf->text())!="")
 	 {
 	  warnbox->setText(tr("Devi inserire la partita iva oppure il codice fiscale del fornitore\nnon entrambi"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(this->piva->text())!="" && quote(this->piva->text()).length()!=11)
 	 {
 	  warnbox->setText(tr("Lunghezza partita iva errata"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(this->cf->text())!="" && quote(this->cf->text()).length()!=16)
 	 {
 	  warnbox->setText(tr("Lunghezza codice fiscale errata"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(this->email->text())!="" && !reg_email->exactMatch(quote(this->email->text())))
 	 {
 	  warnbox->setText(tr("Formato email errato"));
 	  warnbox->exec();
 	  return true;
 	 }
 	return false;
 }

void ARFornitore::visIndirReso()
 {
	MYSQL_RES *rs;
 	MYSQL_ROW row;
 	QString a_nome,a_indr,a_cap,a_citta,a_prov;
 	int r;
 	
 	tableindr->setRowCount(0);
 	r=0;
 	rs=sql->doQueryRS("SELECT * FROM indirizzi_reso WHERE fornitoreID='"+fornitoreID+"' ORDER BY indirizzo");
 	if(rs)
 	 {
 	  while((row=mysql_fetch_row(rs)))
     {
   	  tableindr->insertRow(r); tableindr->setRowHeight(r,18);
   	  a_nome=row[2]; a_indr=row[3]; a_cap=row[4];
   	  a_citta=row[5]; a_prov=row[6];
   	  if(a_nome!="") a_nome=a_nome+" ";
   	  a_indr=a_nome+a_indr+" "+a_cap+" "+a_citta;
   	  if(a_prov!="") a_indr+=" ("+a_prov+")";
   	  tableindr->setItem(r,0,inserisciRiga(row[0]));
   	  tableindr->setItem(r,1,inserisciRiga(a_indr));
   	  tableindr->setItem(r,2,inserisciRiga(row[7]));
   	  tableindr->setItem(r,3,inserisciRiga(row[8]));
   	  tableindr->setItem(r,4,inserisciRiga(row[9]));
   	  tableindr->setItem(r,5,inserisciRiga(row[10]));
   	  tableindr->setItem(r,6,inserisciRiga(row[11]));
      r++;
     }
    mysql_free_result(rs);
   }
 }

QTableWidgetItem *ARFornitore::inserisciRiga(QString str)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	return item;
 }

QTableWidgetItem *ARFornitore::inserisciRiga(const char *str)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	return item;
 }

QString ARFornitore::quote(QString str, bool like)
 {
 	if(like)
 	 {
 	  str.replace('\\',"\\\\\\\\");
 	  str.replace('\'',"\\'");
 	 }
 	else
   {
 	  str.replace('\\',"\\\\");
 	  str.replace('\'',"\\'");
   }
 	return str;
 }

void ARFornitore::settaFormAdd()
 {
  cornice->setGeometry(2,0,650,420);
  cornice->setTitle(tr("Inserisci nuovo fornitore "));
  esegui->setText(tr("Inserisci"));
  esegui->setIcon(QIcon("pic/fornitori_add.png"));
  esegui->setGeometry(543,393,106,24);
  _indireso->setVisible(false);
  tableindr->setVisible(false);
  addindr->setVisible(false);
  editindr->setVisible(false);
  delindr->setVisible(false);
 }

void ARFornitore::settaFormEdit()
 {
  cornice->setGeometry(2,0,798,489);
  cornice->setTitle(tr("Visualizza fornitore "));
  esegui->setText(tr("Salva modifiche"));
  esegui->setIcon(QIcon("pic/floppy.png"));
  esegui->setGeometry(643,350,146,24);
  _indireso->setVisible(true);
  tableindr->setVisible(true);
  addindr->setVisible(true);
  editindr->setVisible(true);
  delindr->setVisible(true);
 }

void ARFornitore::setFornitoreID(QString forID) { fornitoreID=forID; }

void ARFornitore::setAzione(int azio) { azione=azio; }

bool ARFornitore::isAzione(int azio) { if(azione==azio) return true; else return false; }
