#include <QTableWidget>
#include <QTableWidgetItem>
#include <QGroupBox>
#include <QPushButton>
#include <QLineEdit>
#include <QLabel>
#include <QMessageBox>
#include <QMenu>
#include <QAction>
#include <QContextMenuEvent>

#include "ARFinestra.h"
#include "ARsql.h"

#include "ARGrigliaFor.h"

ARGrigliaFor::ARGrigliaFor(QWidget *parent) : QWidget(parent)
 {
 	mainWin=(ARFinestra *)parent;
 	num_col=17;
 	sql = new ARsql(this);
  infobox  = new QMessageBox(tr("Informazioni"),"",QMessageBox::Question,0,0,0,this);
  warnbox  = new QMessageBox(tr("Avviso"),"",QMessageBox::Warning,0,0,0,this);
  yesnobox = new QMessageBox(tr("Scegli"),"",QMessageBox::Question,QMessageBox::Yes,QMessageBox::No,QMessageBox::NoButton,this);
 	cornice = new QGroupBox(tr("Ricerca fornitore "),this);

  _nome  = new QLabel(tr("Nome"),cornice);        _nome->setGeometry (  8, 15,  80, 24);
  nome  = new QLineEdit("",cornice);              nome->setGeometry  ( 68, 15, 240, 24);
  nome->setMaxLength(255);
  _indr  = new QLabel(tr("Indirizzo"),cornice);   _indr->setGeometry (318, 15,  80, 24);
  indr  = new QLineEdit("",cornice);              indr->setGeometry  (368, 15, 320, 24);
  indr->setMaxLength(255);
  _citta = new QLabel(tr("Citt"),cornice);       _citta->setGeometry(  8, 45,  80, 24);
  citta = new QLineEdit("",cornice);              citta->setGeometry ( 68, 45, 170, 24);
  citta->setMaxLength(255);
  _prov  = new QLabel(tr("Prov."),cornice);       _prov->setGeometry (248, 45,  80, 24);
  prov  = new QLineEdit("",cornice);              prov->setGeometry  (278, 45,  30, 24);
  prov->setMaxLength(2);
  _tel   = new QLabel(tr("Tel."),cornice);        _tel->setGeometry  (318, 45,  80, 24);
  tel   = new QLineEdit("",cornice);              tel->setGeometry   (348, 45, 150, 24);
  tel->setMaxLength(50);
  _cell  = new QLabel(tr("Cell."),cornice);       _cell->setGeometry (508, 45,  80, 24);
  cell  = new QLineEdit("",cornice);              cell->setGeometry  (538, 45, 150, 24);
  cell->setMaxLength(50);
  _piva  = new QLabel(tr("P. IVA/C.F."),cornice); _piva->setGeometry (  8, 75,  80, 24);
  piva  = new QLineEdit("",cornice);              piva->setGeometry  ( 68, 75, 240, 24);
  indr->setMaxLength(16);

 	edit      = new QPushButton(QIcon("pic/edit.png"),tr("Visualizza"),this);
 	del       = new QPushButton(QIcon("pic/delete.png"),tr("Cancella"),this);
  stampa    = new QPushButton(QIcon("pic/tabulati.png"),tr("Stampa"),this);
  stampaint = new QPushButton(QIcon("pic/intestazione.png"),tr("Stampa intest."),this);
 	reset = new QPushButton(QIcon("pic/no_search.png"),tr("Azzera"),cornice);
  reset->setGeometry(503,83,96,24);
 	search = new QPushButton(QIcon("pic/search.png"),tr("Cerca"),cornice);
  search->setGeometry(601,83,96,24);
 	table = new QTableWidget(this);
  table->setSortingEnabled(true);
  table->setAlternatingRowColors(true);
  table->setEditTriggers(QAbstractItemView::NoEditTriggers);
  table->setSelectionMode(QAbstractItemView::SingleSelection);
  table->setSelectionBehavior(QAbstractItemView::SelectRows);
 	for(int i=0;i<num_col;i++)    table->insertColumn(i);
 	table->setColumnWidth(0,20);  table->hideColumn(0);
 	table->setColumnWidth(1,100);
 	table->setColumnWidth(2,200);
 	table->setColumnWidth(3,60);
 	table->setColumnWidth(4,85);
 	table->setColumnWidth(5,85);
 	table->setColumnWidth(6,85);
 	table->setColumnWidth(7,90);
 	table->setColumnWidth(8,90);
 	table->setColumnWidth(9,90);
 	table->setColumnWidth(10,110);
 	table->setColumnWidth(11,70);
 	table->setColumnWidth(12,70);
 	table->setColumnWidth(13,80);
 	table->setColumnWidth(14,80);
 	table->setColumnWidth(15,10); table->hideColumn(15);
 	table->setColumnWidth(16,10); table->hideColumn(16);
 	table->setHorizontalHeaderLabels(QStringList() << "ID" << "Nome" << "Indirizzo" << "Nazione" << "Tel." << "Fax" << "Cell." << "P. IVA/C.F." << "Email" << "Sito web" << "Banca" << "ABI" << "CAB" << "CIN" << "CC");
 	
 	mmagCMnu=new QAction(QIcon("pic/scarico.png"),tr("Mostra magazzino relativo al fornitore"),this);
 	editCMnu=new QAction(QIcon("pic/edit.png"),tr("Visualizza il fornitore selezionato"),this);
 	delCMnu=new QAction(QIcon("pic/delete.png"),tr("Cancella il fornitore selezionato"),this);
 	
 	connect(del,SIGNAL(clicked()),this,SLOT(delFornitori()));
 	connect(search,SIGNAL(clicked()),this,SLOT(visFornitori()));
 	connect(reset,SIGNAL(clicked()),this,SLOT(resRicerca()));
  connect(nome,SIGNAL(returnPressed()),this,SLOT(visFornitori()));
  connect(indr,SIGNAL(returnPressed()),this,SLOT(visFornitori()));
  connect(citta,SIGNAL(returnPressed()),this,SLOT(visFornitori()));
  connect(prov,SIGNAL(returnPressed()),this,SLOT(visFornitori()));
  connect(tel,SIGNAL(returnPressed()),this,SLOT(visFornitori()));
  connect(cell,SIGNAL(returnPressed()),this,SLOT(visFornitori()));
  connect(piva,SIGNAL(returnPressed()),this,SLOT(visFornitori()));
  // Menu contestuale
  connect(delCMnu,SIGNAL(triggered()),this,SLOT(delFornitori()));

 	infobox->setWindowModality(Qt::WindowModal);
 	warnbox->setWindowModality(Qt::WindowModal);
 	yesnobox->setWindowModality(Qt::WindowModal);
 	yesnobox->setButtonText(QMessageBox::Yes,tr("Si"));
 	yesnobox->setButtonText(QMessageBox::No,tr("No"));
  hide();
 }

void ARGrigliaFor::settaGeometria(int lar, int alt)
 {
  setGeometry(0,61,lar,alt-70);
 	table->setGeometry(0,0,lar,alt-220);
 	cornice->setGeometry(2,alt-222,700,110);
  edit->setGeometry     (704,alt-213,96,24);
  del->setGeometry      (704,alt-188,96,24);
  stampa->setGeometry   (704,alt-163,96,24);
  stampaint->setGeometry(704,alt-138,96,24);
 }

void ARGrigliaFor::visFornitori()
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;
 	QString query,nome,indr,citta,prov,tel,cell,piva;
 	bool primo;
 	int r;
 	
 	table->setRowCount(0);
 	r=0; primo=true;
 	query="SELECT * FROM fornitori";
 	nome = quote(this->nome->text(),true);
 	indr = quote(this->indr->text(),true);
 	citta= quote(this->citta->text(),true);
 	prov = quote(this->prov->text(),true);
 	tel   = quote(this->tel->text(),true);
 	cell  = quote(this->cell->text(),true);
 	piva  = quote(this->piva->text(),true);
 	if(nome!="")  { if(primo) { query+=" WHERE nome LIKE '%"+nome+"%'"; primo=false; } else { query+=" AND nome LIKE '%"+nome+"%'"; } }
 	if(indr!="")  { if(primo) { query+=" WHERE indirizzo LIKE '%"+indr+"%'"; primo=false; } else { query+=" AND indirizzo LIKE '%"+indr+"%'"; } }
 	if(citta!="") { if(primo) { query+=" WHERE citta LIKE '%"+citta+"%'"; primo=false; } else { query+=" AND citta LIKE '%"+citta+"%'"; } }
 	if(prov!="")  { if(primo) { query+=" WHERE provincia LIKE '%"+prov+"%'"; primo=false; } else { query+=" AND provincia LIKE '%"+prov+"%'"; } }
  if(tel!="")   { if(primo) { query+=" WHERE tel LIKE '%"+tel+"%'"; primo=false; } else { query+=" AND tel LIKE '%"+tel+"%'"; } }
 	if(cell!="")  { if(primo) { query+=" WHERE cell LIKE '%"+cell+"%'"; primo=false; } else { query+=" AND cell LIKE '%"+cell+"%'"; } }
 	if(piva!="")  { if(primo) { query+=" WHERE (piva LIKE '%"+piva+"%' OR cf LIKE '%"+piva+"%')"; primo=false; } else { query+=" AND (piva LIKE '%"+piva+"%' OR cf LIKE '%"+piva+"%')"; } }	
 	query+=" ORDER BY nome";
 	rs=sql->doQueryRS(query);
 	
 	QString a_indr,a_cap,a_citta,a_prov,a_piva,a_cf;
 	if(rs)
 	 {
 	  while((row=mysql_fetch_row(rs)))
     {
   	  table->insertRow(r); table->setRowHeight(r,18);
   	  a_indr=row[3]; a_cap=row[4]; a_citta=row[5]; a_prov=row[6];
   	  a_indr=a_indr+"   "+a_cap+" "+a_citta;
   	  if(a_prov!="") a_indr+=" ("+a_prov+")";
   	  table->setItem(r,0,inserisciRiga(row[0]));
   	  table->setItem(r,1,inserisciRiga(row[1]));
   	  table->setItem(r,2,inserisciRiga(a_indr));
   	  table->setItem(r,3,inserisciRiga(row[7]));
   	  table->setItem(r,4,inserisciRiga(row[8]));
   	  table->setItem(r,5,inserisciRiga(row[9]));
   	  table->setItem(r,6,inserisciRiga(row[10]));
   	  a_piva=row[11]; a_cf=row[12];
   	  if(a_piva!="") table->setItem(r,7,inserisciRiga(a_piva));
   	  else           table->setItem(r,7,inserisciRiga(a_cf));
   	  table->setItem(r,8,inserisciRiga(row[18]));
   	  table->setItem(r,9,inserisciRiga(row[19]));
   	  table->setItem(r,10,inserisciRiga(row[13]));
   	  table->setItem(r,11,inserisciRiga(row[14]));
   	  table->setItem(r,12,inserisciRiga(row[15]));
   	  table->setItem(r,13,inserisciRiga(row[16]));
   	  table->setItem(r,14,inserisciRiga(row[17]));

   	  a_indr=row[3]; a_citta=a_cap+" "+a_citta;
   	  if(a_prov!="") a_citta+=" ("+a_prov+")";
   	  table->setItem(r,15,inserisciRiga(a_indr));  // Invisibili, servono per
   	  table->setItem(r,16,inserisciRiga(a_citta)); // la stampa
   	  r++;
     }
    mysql_free_result(rs);
    if(r==0) 
     {
     	if(infobox->isHidden())
     	 {
     	  infobox->setText(tr("Nessun fornitore trovato!"));
 	      infobox->exec();
 	     }
     }
   }
 }

void ARGrigliaFor::delFornitori()
 {
 	MYSQL_RES *rs=NULL,*rs2;
 	QString fornitoreID;

  if(table->currentRow()<0)
   {
    warnbox->setText(tr("Nessun fornitore selezionato."));
 	  warnbox->exec();
 	  return;
   }
  yesnobox->setText(tr("Vuoi veramente cancellare il fornitore?"));
  if(yesnobox->exec()==QMessageBox::No) return;
  
  // Entro nella sezione critica
  mainWin->sql->connetti();
  if(!mainWin->sql->isBloccatoPer(sql->getDbName()+".carico")   ||
     !mainWin->sql->isBloccatoPer(sql->getDbName()+".scadenze") ||
     !mainWin->sql->isBloccatoPer(sql->getDbName()+".articoli")) // .carico_n .scadenze_n .articoli_n
       {
        warnbox->setText(tr("Un'altro utente sta occupando la sezione fornitori,\nnon posso cancellare il fornitore adesso. Riprova pi tardi."));
 	      warnbox->exec();
        mainWin->sql->disconnetti();
        mysql_free_result(rs);
        return;
       }
  fornitoreID=table->item(table->currentRow(),0)->text();
  rs2=sql->doQueryRS("SELECT * FROM bolle WHERE fornitoreID='"+fornitoreID+"'");
  if(mysql_num_rows(rs2)>0)
   {
   	warnbox->setText(tr("Non posso cancellare il fornitore poich\nsono presenti documenti di trasporto a suo nome."));
    warnbox->exec();
    mysql_free_result(rs2);
    mainWin->sql->disconnetti();
    return;
   }
  mysql_free_result(rs2);
  rs2=sql->doQueryRS("SELECT * FROM scadenze WHERE fornitoreID='"+fornitoreID+"'");
  if(mysql_num_rows(rs2)>0)
   {
   	warnbox->setText(tr("Non posso cancellare il fornitore poich\nsono presenti scadenze a suo nome."));
    warnbox->exec();
    mysql_free_result(rs2);
    mainWin->sql->disconnetti();
    return;
   }
  mysql_free_result(rs2);
  rs=sql->doQueryRS("SELECT * FROM articoli WHERE fornitoreID='"+fornitoreID+"'");
  if(rs)
   {
    if(mysql_num_rows(rs)==0)
     {
      if(mainWin->sql->bloccaPer(mainWin->sql->getDbName()+".articoli","0")) 
       {
   	    sql->doQuery("DELETE FROM fornitori WHERE fornitoreID='"+fornitoreID+"'");
        sql->doQuery("DELETE FROM indirizzi_reso WHERE fornitoreID='"+fornitoreID+"'");
        infobox->setText(tr("Fornitore cancellato!"));
       }
      else { infobox->setText(tr("Non posso cancellere il fornitore poich occupato da un'altro utente!")); }
      infobox->exec();
      visFornitori();
     }
    else
     {
   	  warnbox->setText(tr("Non posso cancellare il fornitore poich\nsono presenti, in magazzino, articoli da esso forniti."));
      warnbox->exec();
     }
    mysql_free_result(rs);
   }
  mainWin->sql->disconnetti();
 }

void ARGrigliaFor::resRicerca()
 {
 	nome->clear();
 	indr->clear();
 	citta->clear();
 	prov->clear();
 	tel->clear();
 	cell->clear();
 	piva->clear();
 	visFornitori();
 }

void ARGrigliaFor::contextMenuEvent(QContextMenuEvent *event)
 {
  QMenu menu(this);
  menu.addAction(mmagCMnu);
  menu.addSeparator();
  menu.addAction(editCMnu);
  menu.addAction(delCMnu);
  menu.exec(event->globalPos());
 }

QTableWidgetItem *ARGrigliaFor::inserisciRiga(QString str)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	return item;
 }

QTableWidgetItem *ARGrigliaFor::inserisciRiga(const char *str)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	return item;
 }

QString ARGrigliaFor::quote(QString str, bool like)
 {
 	if(like)
 	 {
 	  str.replace('\\',"\\\\\\\\");
 	  str.replace('\'',"\\'");
 	 }
 	else
   {
 	  str.replace('\\',"\\\\");
 	  str.replace('\'',"\\'");
   }
 	return str;
 }
