#include <QTableWidget>
#include <QTableWidgetItem>
#include <QGroupBox>
#include <QPushButton>
#include <QLineEdit>
#include <QLabel>
#include <QMessageBox>

#include "ARFinestra.h"
#include "ARsql.h"

#include "ARGrigliaOpt.h"

ARGrigliaOpt::ARGrigliaOpt(QWidget *parent) : QWidget(parent)
 {
 	mainWin=(ARFinestra *)parent;
 	num_col=5;
 	sql = new ARsql(this);
  infobox  = new QMessageBox(tr("Informazioni"),"",QMessageBox::Question,0,0,0,this);
  warnbox  = new QMessageBox(tr("Avviso"),"",QMessageBox::Warning,0,0,0,this);
  yesnobox = new QMessageBox(tr("Scegli"),"",QMessageBox::Question,QMessageBox::Yes,QMessageBox::No,QMessageBox::NoButton,this);
 	cornice = new QGroupBox(tr("Ricerca colore "),this);

  _codice  = new QLabel(tr("Codice"),cornice);    _codice->setGeometry( 8,15, 80, 24);
  codice  = new QLineEdit("",cornice);            codice->setGeometry (68,15,200, 24);
  codice->setMaxLength(255);
  _descr = new QLabel(tr("Descrizione"),cornice); _descr->setGeometry ( 8,45, 80, 24);
  descr = new QLineEdit("",cornice);              descr->setGeometry  (68,45,400, 24);
  descr->setMaxLength(255);
  _etich = new QLabel(tr("Etichetta"),cornice);   _etich->setGeometry ( 8,75, 80, 24);
  etich = new QLineEdit("",cornice);              etich->setGeometry  (68,75,200, 24);
  etich->setMaxLength(255);

 	edit      = new QPushButton(QIcon("pic/edit.png"),tr("Visualizza"),this);
  //edit->setGeometry(704,385,96,24);
 	del       = new QPushButton(QIcon("pic/delete.png"),tr("Cancella"),this);
  //del->setGeometry(704,410,96,24);
  stampa    = new QPushButton(QIcon("pic/tabulati.png"),tr("Stampa"),this);
  //stampa->setGeometry(704,435,96,24);
 	reset = new QPushButton(QIcon("pic/no_search.png"),tr("Azzera"),this);
 	
 	  reset->setGeometry(503,83,96,24);
 	
  
 	
 	
 	
  //reset->setGeometry(505,461,96,24);
 	search = new QPushButton(QIcon("pic/search.png"),tr("Cerca"),this);
  //search->setGeometry(603,461,96,24);
  search->setGeometry(601,83,96,24);
 	table = new QTableWidget(this);
  table->setSortingEnabled(true);
  table->setAlternatingRowColors(true);
  table->setEditTriggers(QAbstractItemView::NoEditTriggers);
  table->setSelectionMode(QAbstractItemView::SingleSelection);
  table->setSelectionBehavior(QAbstractItemView::SelectRows);
 	for(int i=0;i<num_col;i++) table->insertColumn(i);
 	table->setColumnWidth(0,20);
 	table->setColumnWidth(1,150);
 	table->setColumnWidth(2,320);
 	table->setColumnWidth(3,160);
 	table->setColumnWidth(4,80);
 	table->setHorizontalHeaderLabels(QStringList() << "ID" << "Codice" << "Descrizione" << "Etichetta" << "Default");
 	table->hideColumn(0);
 	
 	connect(del,SIGNAL(clicked()),this,SLOT(delOption()));
 	connect(search,SIGNAL(clicked()),this,SLOT(visClienti()));
 	connect(reset,SIGNAL(clicked()),this,SLOT(resRicerca()));
  connect(codice,SIGNAL(returnPressed()),this,SLOT(visClienti()));
  connect(descr,SIGNAL(returnPressed()),this,SLOT(visClienti()));
  connect(etich,SIGNAL(returnPressed()),this,SLOT(visClienti()));

 	infobox->setWindowModality(Qt::WindowModal);
 	warnbox->setWindowModality(Qt::WindowModal);
 	yesnobox->setWindowModality(Qt::WindowModal);
 	yesnobox->setButtonText(QMessageBox::Yes,tr("Si"));
 	yesnobox->setButtonText(QMessageBox::No,tr("No"));
  hide();
 }

void ARGrigliaOpt::settaGeometria(int lar, int alt)
 {
  setGeometry(0,61,lar,alt-70);
 	table->setGeometry  (0,0,lar,alt-220);
 	cornice->setGeometry(2,alt-222,700,110);
  edit->setGeometry   (704,alt-213,96,24);
  del->setGeometry    (704,alt-188,96,24);
  stampa->setGeometry (704,alt-163,96,24);
 }

void ARGrigliaOpt::visOption()
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;
 	QString query,codice,descr,etich;
 	bool primo;
 	int r;
 	
 	table->setRowCount(0);
 	r=0; primo=true;
 	query ="SELECT * FROM "+tabella;
 	codice = quote(this->codice->text(),true);
 	descr  = quote(this->descr->text(),true);
 	etich  = quote(this->etich->text(),true);
 	if(codice!="") { if(primo) { query+=" WHERE codice LIKE '%"+codice+"%'"; primo=false; }     else { query+=" AND codice LIKE '%"+codice+"%'"; } }
 	if(descr!="")  { if(primo) { query+=" WHERE descrizione LIKE '%"+descr+"%'"; primo=false; } else { query+=" AND descrizione LIKE '%"+descr+"%'"; } }
 	if(etich!="")  { if(primo) { query+=" WHERE etichetta LIKE '%"+etich+"%'"; primo=false; }   else { query+=" AND etichetta LIKE '%"+etich+"%'"; } }
 	query+=" ORDER BY descrizione";
 	rs=sql->doQueryRS(query);
 	
 	if(rs)
 	 {
 	  while((row=mysql_fetch_row(rs)))
     {
   	  table->insertRow(r); table->setRowHeight(r,18);
   	  table->setItem(r,0,inserisciRiga(row[0]));
   	  table->setItem(r,1,inserisciRiga(row[1]));
   	  table->setItem(r,2,inserisciRiga(row[2]));
   	  table->setItem(r,3,inserisciRiga(row[3]));
   	  table->setItem(r,4,inserisciRiga(row[4]));
   	  r++;
     }
    mysql_free_result(rs);
    if(r==0) 
     {
     	if(infobox->isHidden())
     	 {
     	  infobox->setText(tr("Nessuna opzione trovata!"));
 	      infobox->show();
 	     }
     }
   }
 }

void ARGrigliaOpt::delOption()
 {
 	MYSQL_RES *rs;
 	QString optionID;

  if(table->currentRow()<0)
   {
    warnbox->setText(tr("Nessun elemento selezionato."));
 	  warnbox->show();
 	  return;
   }
  yesnobox->setText(tr("Vuoi veramente cancellare l'opzione?"));
  if(yesnobox->exec()==QMessageBox::No) return;
  optionID=table->item(table->currentRow(),0)->text();
  rs=sql->doQueryRS("SELECT * FROM articoli WHERE "+nomeID+"='"+optionID+"'");
  if(rs)
   {
    if(mysql_num_rows(rs)==0)
     {
     	// Entro nella sezione critica
      mainWin->sql->connetti();
      if(!mainWin->sql->isBloccatoPer(sql->getDbName()+".carico")) // .carico_n
       {
        warnbox->setText(tr("Un'altro utente sta occupando la sezione opzioni articoli,\nnon posso cancellare l'opzione adesso. Riprova pi tardi."));
 	      warnbox->exec();
        mainWin->sql->disconnetti();
        return;
       }
      mainWin->sql->disconnetti();
   	  sql->doQuery("DELETE FROM "+tabella+" WHERE "+nomeID+"='"+optionID+"'");
      infobox->setText(tr("Opzione cancellata!"));
      infobox->show();
      visOption();
     }
    else
     {
   	  warnbox->setText(tr("Non posso cancellare l'opzione poich\nsono presenti, in magazzino, articoli con questa opzione attiva."));
      warnbox->show();
     }
    mysql_free_result(rs);
   }
 }

void ARGrigliaOpt::resRicerca()
 {
 	codice->clear();
 	descr->clear();
 	etich->clear();
 	visOption();
 }

QTableWidgetItem *ARGrigliaOpt::inserisciRiga(QString str)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	return item;
 }

QTableWidgetItem *ARGrigliaOpt::inserisciRiga(const char *str)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	return item;
 }

void ARGrigliaOpt::setTabella(QString tbl) { tabella=tbl; }

QString ARGrigliaOpt::getTabella() { return tabella; }

void ARGrigliaOpt::setNomeID(QString nID) { nomeID=nID; }

QString ARGrigliaOpt::quote(QString str, bool like)
 {
 	if(like)
 	 {
 	  str.replace('\\',"\\\\\\\\");
 	  str.replace('\'',"\\'");
 	 }
 	else
   {
 	  str.replace('\\',"\\\\");
 	  str.replace('\'',"\\'");
   }
 	return str;
 }
