#include <QTableWidget>
#include <QTableWidgetItem>
#include <QGroupBox>
#include <QPushButton>
#include <QLineEdit>
#include <QLabel>
#include <QMessageBox>
#include <QMenu>
#include <QAction>
#include <QContextMenuEvent>

#include "ARFinestra.h"
#include "ARsql.h"

#include "ARGrigliaSer.h"

ARGrigliaSer::ARGrigliaSer(QWidget *parent) : QWidget(parent)
 {
 	mainWin=(ARFinestra *)parent;
 	num_col=7;
 	sql = new ARsql(this);
  infobox  = new QMessageBox(tr("Informazioni"),"",QMessageBox::Question,0,0,0,this);
  warnbox  = new QMessageBox(tr("Avviso"),"",QMessageBox::Warning,0,0,0,this);
  yesnobox = new QMessageBox(tr("Scegli"),"",QMessageBox::Question,QMessageBox::Yes,QMessageBox::No,QMessageBox::NoButton,this);
 	cornice  = new QGroupBox(tr("Ricerca cliente "),this);

  _articolo    = new QLabel(tr("Codice"),cornice);      _articolo->setGeometry   (  8, 15,  80, 24);
  articolo     = new QLineEdit("",cornice);             articolo->setGeometry    ( 48, 15, 240, 24);
  articolo->setMaxLength(255);
  _descrizione = new QLabel(tr("Descrizione"),cornice); _descrizione->setGeometry(298, 15,  80, 24);
  descrizione  = new QLineEdit("",cornice);             descrizione->setGeometry (358, 15, 334, 24);
  descrizione->setMaxLength(255);
  _prezzo = new QLabel(tr("Prezzo"),cornice);           _prezzo->setGeometry     (  8, 45,  80, 24);
  prezzo = new QLineEdit("",cornice);                   prezzo->setGeometry      ( 48, 45, 130, 24);
  prezzo->setMaxLength(35);
  _iva  = new QLabel(tr("IVA(%)"),cornice);             _iva->setGeometry        (188, 45,  80, 24);
  iva  = new QLineEdit("",cornice);                     iva->setGeometry         (228, 45,  60, 24);
  iva->setMaxLength(3);
  _note   = new QLabel(tr("Note"),cornice);             _note->setGeometry       (298, 45,  80, 24);
  note   = new QLineEdit("",cornice);                   note->setGeometry        (358, 45, 334, 24);
  note->setMaxLength(255);

 	edit      = new QPushButton(QIcon("pic/edit.png"),tr("Visualizza"),this);
 	del       = new QPushButton(QIcon("pic/delete.png"),tr("Cancella"),this);
  stampa    = new QPushButton(QIcon("pic/tabulati.png"),tr("Stampa"),this);
 	reset = new QPushButton(QIcon("pic/no_search.png"),tr("Azzera"),cornice);
  reset->setGeometry(503,83,96,24);
 	search = new QPushButton(QIcon("pic/search.png"),tr("Cerca"),cornice);
  search->setGeometry(601,83,96,24);
 	table = new QTableWidget(this);
  table->setSortingEnabled(true);
  table->setAlternatingRowColors(true);
  table->setEditTriggers(QAbstractItemView::NoEditTriggers);
  table->setSelectionMode(QAbstractItemView::SingleSelection);
  table->setSelectionBehavior(QAbstractItemView::SelectRows);
 	for(int i=0;i<num_col;i++) table->insertColumn(i);
 	table->setColumnWidth(0,20);
 	table->setColumnWidth(1,150);
 	table->setColumnWidth(2,300);
 	table->setColumnWidth(3,100);
 	table->setColumnWidth(4,50);
 	table->setColumnWidth(5,100);
 	table->setColumnWidth(6,380);
 	table->setHorizontalHeaderLabels(QStringList() << "ID" << "Codice" << "Descrizione" << "Prezzo unitario" << "IVA(%)" << "Prezzo ivato" << "Note");
 	table->hideColumn(0);

 	editCMnu=new QAction(QIcon("pic/edit.png"),tr("Visualizza il servizio selezionato"),this);
 	delCMnu=new QAction(QIcon("pic/delete.png"),tr("Cancella il servizio selezionato"),this);
 	
 	connect(del,SIGNAL(clicked()),this,SLOT(delServizi()));
 	connect(search,SIGNAL(clicked()),this,SLOT(visServizi()));
 	connect(reset,SIGNAL(clicked()),this,SLOT(resRicerca()));
  connect(articolo,SIGNAL(returnPressed()),this,SLOT(visServizi()));
  connect(descrizione,SIGNAL(returnPressed()),this,SLOT(visServizi()));
  connect(prezzo,SIGNAL(returnPressed()),this,SLOT(visServizi()));
  connect(iva,SIGNAL(returnPressed()),this,SLOT(visServizi()));
  connect(note,SIGNAL(returnPressed()),this,SLOT(visServizi()));
  // Menu contestuale
  connect(delCMnu,SIGNAL(triggered()),this,SLOT(delServizi()));

 	infobox->setWindowModality(Qt::WindowModal);
 	warnbox->setWindowModality(Qt::WindowModal);
 	yesnobox->setWindowModality(Qt::WindowModal);
 	yesnobox->setButtonText(QMessageBox::Yes,tr("Si"));
 	yesnobox->setButtonText(QMessageBox::No,tr("No"));
  hide();
 }

void ARGrigliaSer::settaGeometria(int lar, int alt)
 {
  setGeometry(0,61,lar,alt-70);
 	table->setGeometry  (0,0,lar,alt-220);
 	cornice->setGeometry(2,alt-222,700,110);
  edit->setGeometry   (704,alt-213,96,24);
  del->setGeometry    (704,alt-188,96,24);
  stampa->setGeometry (704,alt-163,96,48);
 }

void ARGrigliaSer::visServizi()
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;
 	QString query,articolo,descrizione,prezzo,iva,note;
 	bool primo;
 	int r;
 	
 	table->setRowCount(0);
 	r=0; primo=true;
 	query = "SELECT *,TRUNCATE(prezzo+prezzo*iva/100,2) AS ivato FROM servizi";
 	articolo    = quote(this->articolo->text(),true);
 	descrizione = quote(this->descrizione->text(),true);
 	prezzo = quote(this->prezzo->text(),true);
 	iva  = quote(this->iva->text(),true);
 	note   = quote(this->note->text(),true);
 	if(articolo!="")    { if(primo) { query+=" WHERE articolo LIKE '%"+articolo+"%'"; primo=false; }     else { query+=" AND articolo LIKE '%"+articolo+"%'"; } }
 	if(descrizione!="") { if(primo) { query+=" WHERE indirizzo LIKE '%"+descrizione+"%'"; primo=false; } else { query+=" AND indirizzo LIKE '%"+descrizione+"%'"; } }
 	if(prezzo!="")      { if(primo) { query+=" WHERE prezzo LIKE '%"+prezzo+"%'"; primo=false; }         else { query+=" AND prezzo LIKE '%"+prezzo+"%'"; } }
 	if(iva!="")         { if(primo) { query+=" WHERE iva='"+iva+"'"; primo=false; }                      else { query+=" AND iva='"+iva+"'"; } }
 	if(note!="")        { if(primo) { query+=" WHERE note LIKE '%"+note+"%'"; primo=false; }             else { query+=" AND note LIKE '%"+note+"%'"; } }
 	query+=" ORDER BY descrizione";
 	rs=sql->doQueryRS(query);

 	if(rs)
 	 {
 	  while((row=mysql_fetch_row(rs)))
     {
   	  table->insertRow(r); table->setRowHeight(r,18);
   	  table->setItem(r,0,inserisciRiga(row[0]));
   	  table->setItem(r,1,inserisciRiga(row[1]));
   	  table->setItem(r,2,inserisciRiga(row[2]));
   	  table->setItem(r,3,inserisciRiga(row[3],Qt::AlignRight));
   	  table->setItem(r,4,inserisciRiga(row[4],Qt::AlignRight));
   	  table->setItem(r,5,inserisciRiga(row[9],Qt::AlignRight)); // Prezzo ivato
   	  table->setItem(r,6,inserisciRiga(row[5])); // Note   	  
   	  r++;
     }
    mysql_free_result(rs);
    if(r==0) 
     {
     	if(infobox->isHidden())
     	 {
     	  infobox->setText(tr("Nessun servizio trovato!"));
 	      infobox->exec();
 	     }
     }
   }
 }

void ARGrigliaSer::delServizi()
 {
 	//MYSQL_RES *rs;
 	QString servizioID;

  if(table->currentRow()<0)
   {
    warnbox->setText(tr("Nessun servizio selezionato."));
 	  warnbox->exec();
 	  return;
   }
  yesnobox->setText(tr("Vuoi veramente cancellare il servizio?"));
  if(yesnobox->exec()==QMessageBox::No) return;
  servizioID=table->item(table->currentRow(),0)->text();
  sql->doQuery("DELETE FROM servizi WHERE servizioID='"+servizioID+"'");
  infobox->setText(tr("Servizio cancellato!"));
  infobox->exec();
  visServizi();
 }

void ARGrigliaSer::resRicerca()
 {
 	articolo->clear();
 	descrizione->clear();
 	prezzo->clear();
 	iva->clear();
 	note->clear();
 	visServizi();
 }

void ARGrigliaSer::contextMenuEvent(QContextMenuEvent *event)
 {
  QMenu menu(this);
  menu.addAction(editCMnu);
  menu.addAction(delCMnu);
  menu.exec(event->globalPos());
 }

QTableWidgetItem *ARGrigliaSer::inserisciRiga(QString str, int alig)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	item->setTextAlignment(alig);
 	return item;
 }

QTableWidgetItem *ARGrigliaSer::inserisciRiga(const char *str, int alig)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	item->setTextAlignment(alig);
 	return item;
 }

QString ARGrigliaSer::quote(QString str, bool like)
 {
 	if(like)
 	 {
 	  str.replace('\\',"\\\\\\\\");
 	  str.replace('\'',"\\'");
 	 }
 	else
   {
 	  str.replace('\\',"\\\\");
 	  str.replace('\'',"\\'");
   }
 	return str;
 }
