#ifndef ARSCADENZA_H
#define ARSCADENZA_H

#define ARSCADENZA_ADD  0
#define ARSCADENZA_EDIT 1

#include <QWidget>

class QPushButton;
class QGroupBox;
class QComboBox;
class QTextEdit;
class QLabel;
class QDateEdit;
class QDate;
class QLineEdit;
class QMessageBox;

class ARFinestra;
class ARsql;

class ARScadenza : public QWidget
 {
  Q_OBJECT

  public:
   QGroupBox *cornice;
   QComboBox *listaFor,*listaStato;
   QPushButton *esegui;
   QLineEdit *descr,*somma;
   QDateEdit *scade;
   QTextEdit *note;
   
   ARScadenza(QWidget *parent = 0);
   bool setForm(QString);
   void clearForm();
   void setScadenzaID(QString);
   void setAzione(int);
   bool isAzione(int);
   bool populateFor(QString);
   void settaFormAdd();
   void settaFormEdit();

  public slots:
   void addScadenza();
   
  private:
   ARFinestra *mainWin;
   ARsql *sql;
   QMessageBox *infobox,*warnbox;
   QString scadenzaID;
   QLabel *_for,*_descr,*_somma,*_scade,*_note,*_stato;
   int azione;

   bool checkForm();
   QString quote(QString, bool like = false);   
 };

#endif
