#include <QTextDocument>
#include <QDateTime>
#include <QDate>
#include <QTextEdit>
#include <QPushButton>
#include <QGroupBox>
#include <QLabel>
#include <QLineEdit>
#include <QTextEdit>
#include <QTabWidget>
#include <QMessageBox>
#include <QImage>
#include <QScrollArea>
#include <QPainter>
#include <QComboBox>

#include "ARsql.h"
#include "ARFinestra.h"

#include "ARStat.h"

ARStat::ARStat(QWidget *parent) : QWidget(parent)
 {
 	mainWin=(ARFinestra *)parent;
 	sql = new ARsql(this);
 	infobox = new QMessageBox(tr("Informazioni"),"",QMessageBox::Question,0,0,0,this);
 	warnbox = new QMessageBox(tr("Avviso"),"",QMessageBox::Warning,0,0,0,this);

 	tpage1 = new QWidget(this);
  tpage2 = new QWidget(this);
  tpage3 = new QWidget(this);
  tab = new QTabWidget(this);
  tab->addTab(tpage1,QIcon("pic/stat.png"),tr("Riepilogo"));
  tab->addTab(tpage2,QIcon("pic/stat.png"),tr("Andamenti"));
  tab->addTab(tpage3,QIcon("pic/stat.png"),tr("Statistiche"));

  // Riepilogo
  riep_html = new QTextDocument("",this);
  riep      = new QTextEdit("",tpage1);
  riep->setDocument(riep_html); 
  riep->setReadOnly(true);
  stampa1   = new QPushButton(QIcon("pic/stat.png"),tr("Stampa"),tpage1);

  // Andamenti
 	cornice = new QGroupBox(tr("Imposta grafico "),tpage2);
  stampa2 = new QPushButton(QIcon("pic/stat.png"),tr("Stampa"),tpage2);
  _mostra = new QLabel("Mostra",cornice); _mostra->setGeometry    (10,20,80,24);
  listaMostra = new QComboBox(cornice);   listaMostra->setGeometry(50,20,120,24);
  listaMostra->addItem(tr("Guadagno (euro)"),QVariant("0"));
  _step     = new QLabel("per",cornice);  _step->setGeometry      (180,20,80,24);
  listaStep = new QComboBox(cornice);     listaStep->setGeometry  (205,20,90,24);
  listaStep->addItem(tr("Anni"),QVariant("0"));
  listaStep->addItem(tr("Mesi"),QVariant("1"));
  listaStep->addItem(tr("Giorni"),QVariant("2"));
  pic  = new QImage(0,0,QImage::Format_RGB32);
  _pic = new QLabel("",tpage2);
  _pic->setBackgroundRole(QPalette::Dark);
  _pic->setAlignment(Qt::AlignTop); 
  area = new QScrollArea(tpage2);
  area->setWidget(_pic);
  area->setHorizontalScrollBarPolicy (Qt::ScrollBarAlwaysOn);

  // Statistiche
 	cornice2 = new QGroupBox(tr("Imposta grafico "),tpage3);
  stampa3  = new QPushButton(QIcon("pic/stat.png"),tr("Stampa"),tpage3);
  _mostra2 = new QLabel("Mostra",cornice2); _mostra2->setGeometry    (10,20,80,24);
  listaMostra2 = new QComboBox(cornice2);   listaMostra2->setGeometry(50,20,240,24);
  listaMostra2->addItem(tr("Vendite per clienti (euro)"),QVariant("0"));
  listaMostra2->addItem(tr("Vendite per fornitori (euro)"),QVariant("1"));
  listaMostra2->addItem(tr("Vendite per tipologia merce (euro)"),QVariant("2"));

  pic2  = new QImage(0,0,QImage::Format_RGB32);
  area2 = new QScrollArea(tpage3);
  _pic2 = new QLabel("",tpage2);
  _pic2->setBackgroundRole(QPalette::Dark);
  _pic2->setAlignment(Qt::AlignTop); 
  area2->setWidget(_pic2);
  area2->setHorizontalScrollBarPolicy (Qt::ScrollBarAlwaysOn);

  //connect(stampa1,SIGNAL(clicked()),this,SLOT(stampaRiepilogo???()));
  //connect(stampa2,SIGNAL(clicked()),this,SLOT(stampaRiepilogo???()));
  connect(tab,SIGNAL(currentChanged(int)),this,SLOT(cambiaTab(int)));

 	infobox->setWindowModality(Qt::WindowModal);
 	warnbox->setWindowModality(Qt::WindowModal);
  hide();
 }

void ARStat::cambiaTab(int n)
 {
 	if(n==0) creaRiepilogo();
 	if(n==1) creaTrend();
 	if(n==2) creaStatistica();
 }

void ARStat::creaRiepilogo()
 {
 	QDateTime dt = QDateTime::currentDateTime();
 	QString html,num_for,num_cli,num_fat,num_ddt,num_sca;
  QString tot_sca,tot_fat,tot_fat_iva,tot_fat_anno,tot_fat_anno_iva;
  QString tot_rica,tot_rica_iva,tot_rica_ivato,tot_guad,tot_guad_pezzi,tot_giac,tot_giac_iva,tot_giac_ivato,tot_giac_pezzi,tot_reso,tot_reso_iva,tot_reso_ivato,tot_reso_pezzi;
  QString tot_tipi;
 	QString data_riep,ora_riep;
 	MYSQL_RES *rs;
 	MYSQL_ROW row;

 	// Clienti
 	rs=sql->doQueryRS("SELECT COUNT(*) FROM clienti");
  if(rs) {
          row=mysql_fetch_row(rs);
 	        mysql_free_result(rs);
 	        num_cli=row[0];
 	       }
 	// Fornitori
  rs=sql->doQueryRS("SELECT COUNT(*) FROM fornitori");
  if(rs) {
          row=mysql_fetch_row(rs);
 	        mysql_free_result(rs);
 	        num_for=row[0];
 	       }
 	// D.D.T.
  rs=sql->doQueryRS("SELECT COUNT(*) FROM bolle");
  if(rs) {
          row=mysql_fetch_row(rs);
 	        mysql_free_result(rs);
 	        num_ddt=row[0];
 	       }
 	// Scadenze
  rs=sql->doQueryRS("SELECT COUNT(*) FROM scadenze");
  if(rs) {
          row=mysql_fetch_row(rs);
 	        mysql_free_result(rs);
 	        num_sca=row[0];
 	       }
  rs=sql->doQueryRS("SELECT SUM(somma) FROM scadenze WHERE stato='0'");
  if(rs) {
          row=mysql_fetch_row(rs);
 	        mysql_free_result(rs);
 	        tot_sca=row[0];
 	        if(tot_sca=="") tot_sca="0";
 	       }
 	// Fatture
  rs=sql->doQueryRS("SELECT SUM(prezzo_pub),SUM(prezzo_pub+prezzo_pub*iva/100),COUNT(*) FROM articoli WHERE fatturaID!='0'");
  if(rs) {
          row=mysql_fetch_row(rs);
 	        mysql_free_result(rs);
 	        tot_fat=row[0];
 	        tot_fat_iva=row[1];
 	        num_fat=row[2];
 	        if(tot_fat=="") tot_fat="0";
 	        tot_fat_iva.sprintf("%.2lf",tot_fat_iva.toDouble());
 	       }
 	QDate cur_anno(QDate::currentDate());
  rs=sql->doQueryRS("SELECT SUM(prezzo_pub),SUM(prezzo_pub+prezzo_pub*iva/100) FROM articoli WHERE fatturaID!='0' AND SUBSTRING(data_fat,1,4)='"+cur_anno.toString("yyyy")+"'");
  if(rs) {
          row=mysql_fetch_row(rs);
 	        mysql_free_result(rs);
 	        tot_fat_anno=row[0];
 	        tot_fat_anno_iva=row[1];
 	        if(tot_fat_anno=="") tot_fat_anno="0";
 	        tot_fat_anno_iva.sprintf("%.2lf",tot_fat_anno_iva.toDouble());
 	       }
 	// Riepilogo magazzino
  rs=sql->doQueryRS("SELECT SUM(prezzo_pub-(prezzo+prezzo*(iva/100))),COUNT(*),SUM(prezzo_pub),SUM(prezzo_pub*(iva/100)),SUM(prezzo_pub+prezzo_pub*(iva/100)) FROM articoli WHERE stato='1'");
  if(rs) {
          row=mysql_fetch_row(rs);
 	        mysql_free_result(rs);
 	        tot_guad=row[0];
 	        tot_guad_pezzi=row[1];
 	        tot_rica=row[2];
 	        tot_rica_iva=row[3];
 	        tot_rica_ivato=row[4];
 	        tot_guad.sprintf("%.2lf",tot_guad.toDouble());
 	        tot_rica.sprintf("%.2lf",tot_rica.toDouble());
	        tot_rica_iva.sprintf("%.2lf",tot_rica_iva.toDouble());
          tot_rica_ivato.sprintf("%.2lf",tot_rica_ivato.toDouble());
 	       }
  rs=sql->doQueryRS("SELECT SUM(prezzo),COUNT(*),SUM(prezzo*(iva/100)),SUM(prezzo+prezzo*(iva/100)) FROM articoli WHERE stato='0'");
  if(rs) {
          row=mysql_fetch_row(rs);
 	        mysql_free_result(rs);
 	        tot_giac=row[0];
 	        tot_giac_pezzi=row[1];
 	        tot_giac_iva=row[2];
 	        tot_giac_ivato=row[3];
 	        tot_giac.sprintf("%.2lf",tot_giac.toDouble());
 	        tot_giac_iva.sprintf("%.2lf",tot_giac_iva.toDouble());
 	        tot_giac_ivato.sprintf("%.2lf",tot_giac_ivato.toDouble());
 	       }
  rs=sql->doQueryRS("SELECT SUM(prezzo),COUNT(*),SUM(prezzo*(iva/100)),SUM(prezzo+prezzo*(iva/100)) FROM articoli WHERE stato='2'");
  if(rs) {
          row=mysql_fetch_row(rs);
 	        mysql_free_result(rs);
 	        tot_reso=row[0];
 	        tot_reso_pezzi=row[1];
 	        tot_reso_iva=row[2];
 	        tot_reso_ivato=row[3];
 	        tot_reso.sprintf("%.2lf",tot_reso.toDouble());
 	        tot_reso_iva.sprintf("%.2lf",tot_reso_iva.toDouble());
 	        tot_reso_ivato.sprintf("%.2lf",tot_reso_ivato.toDouble()); 	        
 	       } 	       
  rs=sql->doQueryRS("SELECT COUNT(*) FROM tipi_articolo");
  if(rs) {
          row=mysql_fetch_row(rs);
 	        mysql_free_result(rs);
 	        tot_tipi=row[0];
 	        if(tot_tipi=="") tot_tipi="0";
 	       }
 	data_riep=dt.toString("dd MMMM yyyy (dddd)");
 	ora_riep=dt.toString("hh:mm:ss");
 	html="<table width=100% align=center>";
 	html+="<tr><td><font size+1><b>Riepilogo al "+data_riep+" alle ore "+ora_riep+"</b></font><hr></td></tr>";
 	html+="<tr><td><font size+1 color=#ff0000><b>Riepilogo archivio:</b></font><br></td></tr>";
 	html+="<tr><td><table>";
 	html+="<tr bgcolor=#dddddd><td>&nbsp;<img src=pic/clienti.png>&nbsp;</td><td>  &nbsp;Totale numero clienti:  <br><div align=right><b>"+num_cli+"</b></div>&nbsp;</td></tr>";
 	html+="<tr bgcolor=#ffffff><td>&nbsp;<img src=pic/fornitori.png>&nbsp;</td><td>&nbsp;Totale numero fornitori:<br><div align=right><b>"+num_for+"</b></div>&nbsp;</td></tr>";
 	html+="<tr bgcolor=#dddddd><td>&nbsp;<img src=pic/fatture.png>&nbsp;</td><td>  &nbsp;Totale numero fatture:  <br><div align=right><b>"+num_fat+"</b></div>&nbsp;</td><td> &nbsp;Totale fatture (Euro): <br><div align=right><b>"+tot_fat+" (ivato: "+tot_fat_iva+")</b></div>&nbsp;</td><td> &nbsp;Totale fatture corrente anno (Euro): <br><div align=right><b>"+tot_fat_anno+" (ivato: "+tot_fat_anno_iva+")</b></div>&nbsp;</td></tr>";
 	html+="<tr bgcolor=#ffffff><td>&nbsp;<img src=pic/ddt.png>&nbsp;</td><td>      &nbsp;Totale numero D.D.T.:   <br><div align=right><b>"+num_ddt+"</b></div>&nbsp;</td></tr>";
 	html+="<tr bgcolor=#dddddd><td>&nbsp;<img src=pic/scadenze.png>&nbsp;</td><td> &nbsp;Totale numero scadenze: <br><div align=right><b>"+num_sca+"</b></div>&nbsp;</td><td> &nbsp;Totale scadenze da pagare (Euro): <br><div align=right><b>"+tot_sca+"</b></div>&nbsp;</td></tr>";
 	html+="</table>";
 	html+="<tr><td><hr></td></tr></table>";

 	html+="<table width=100% align=center>";
 	html+="<tr><td><font size+1 color=#ff0000><b>Riepilogo magazzino:</b></font><br></td></tr>";
 	html+="<tr><td><table>";
 	html+="<tr bgcolor=#dddddd><td>&nbsp;<img src=pic/venduto.png>  &nbsp;</td><td>&nbsp;Totale ricavo (Euro):  <br><div align=right><b>"+tot_rica+"</b></div>&nbsp;</td><td>&nbsp;Totale iva ricavo (Euro):???<br><div align=right><b>"+tot_rica_iva+"</b></div>&nbsp;</td><td>&nbsp;Totale ricavo ivato (Euro):???<br><div align=right><b>"+tot_rica_ivato+"</b></div>&nbsp;</td><td>&nbsp;Totale guadagno (Euro):  <br><div align=right><b>"+tot_guad+"</b>      </div>&nbsp;</td><td>&nbsp;Totale articoli venduti:     <br><div align=right><b>"+tot_guad_pezzi+"</b></div>&nbsp;</td></tr>";
 	html+="<tr bgcolor=#ffffff><td>&nbsp;<img src=pic/magazzino.png>&nbsp;</td><td>&nbsp;Totale giacenza (Euro):<br><div align=right><b>"+tot_giac+"</b></div>&nbsp;</td><td>&nbsp;Totale iva giacenza (Euro):<br><div align=right><b>"+tot_giac_iva+"</b></div>&nbsp;</td><td>&nbsp;Totale giacenza ivato (Euro):<br><div align=right><b>"+tot_giac_ivato+"</b></div>&nbsp;</td><td>&nbsp;Totale articoli giacenti:<br><div align=right><b>"+tot_giac_pezzi+"</b></div>&nbsp;</td></tr>";
 	html+="<tr bgcolor=#dddddd><td>&nbsp;<img src=pic/reso.png>     &nbsp;</td><td>&nbsp;Totale reso (Euro):    <br><div align=right><b>"+tot_reso+"</b></div>&nbsp;</td><td>&nbsp;Totale iva reso (Euro):    <br><div align=right><b>"+tot_reso_iva+"</b></div>&nbsp;</td><td>&nbsp;Totale reso ivato (Euro):    <br><div align=right><b>"+tot_reso_ivato+"</b></div>&nbsp;</td><td>&nbsp;Totale articoli resi:    <br><div align=right><b>"+tot_reso_pezzi+"</b></div>&nbsp;</td></tr>";
 	html+="</table>";
 	html+="<tr><td><hr></td></tr></table>";

 	html+="<table width=100% align=center>";
 	html+="<tr><td><font size+1 color=#ff0000><b>Riepilogo articoli:</b></font><br></td></tr>";
 	html+="<tr><td><table>";
 	html+="<tr bgcolor=#dddddd><td>&nbsp;<img src=pic/tipi.png>&nbsp;</td><td>&nbsp;Totale numero tipologie articoli:<br><div align=right>  <b>"+tot_tipi+"</b></div>&nbsp;</td></tr>";
// 	html+="<tr bgcolor=#ffffff><td>&nbsp;                            </td><td>&nbsp;Totale giacenza (Euro al pubblico):<br><div align=right><b>"+tot_giac+"</b></div>&nbsp;</td></tr>";
// 	html+="<tr bgcolor=#dddddd><td>&nbsp;                            </td><td>&nbsp;Totale reso (Euro al pubblico):<br><div align=right>    <b>"+tot_reso+"</b></div>&nbsp;</td></tr>";
 	html+="</table>";
 	html+="<tr><td><hr></td></tr></table>";

 	riep_html->setHtml(html);
 }

void ARStat::creaTrend()
 {
 	int xasse,yasse,maxy,miny,alt,i=0,n=0;
 	double media,sc;

  // lock tabella articoli in scrittura da qui (devono diventare operazioni atomiche)
  QDate data_iniz=prendiDataInizioTrend();
  QDate data_fine=prendiDataFineTrend();
 	n=prendiNumDatiTrend(data_iniz,data_fine);
 	QString lab[n]; QString val[n];
 	prendiDatiTrend(lab,val,data_iniz,data_fine);
 	// a qui

 	// Ricavo max,min e media
 	maxy=miny=0;
 	media=0;
 	for(i=0;i<n;i++)
 	 {
 	 	if((int)val[i].toDouble()>maxy) maxy=(int)val[i].toDouble();
 	 	if((int)val[i].toDouble()<miny) miny=(int)val[i].toDouble();
 	 	media=media+val[i].toDouble();
 	 }
  alt=maxy-miny;
  media=media/(double)n;

  // Inizializzo l'immagine e disegno gli assi
  pic->~QImage();
  if(20+50+n*50>area->width()) pic = new QImage(20+50+n*50,area->height()-20,QImage::Format_RGB32);
  else pic = new QImage(area->width(),area->height()-20,QImage::Format_RGB32);
  pic->fill(0xFFFFFF);
  QPainter tela(pic);
  int pic_alt=(int)((double)pic->height()/(double)1.6);
  if(alt==0) alt=1;
  sc=(double)pic_alt/(double)alt;

  QString tipo=listaStep->itemData(listaStep->currentIndex()).toString();
  if(tipo=="0") { tipo="ANNI"; }
  if(tipo=="1") { tipo="MESI"; }
  if(tipo=="2") { tipo="GIORNI"; }
  yasse=drawAssiTrend(maxy,miny,alt,sc,&tela,tipo,"EURO");
  xasse=0+50;
  
  // Disegna media
  QString aux;
  int v=(int)(-media*sc);
  tela.setPen(QColor(0,0,255));
  tela.drawText(0,yasse-1+v,aux.sprintf("%.2lf",media));  
  tela.drawLine(0,yasse+v,pic->width(),yasse+v);
  tela.setPen(QColor(0,0,0));

  // Disegno il grafico
  for(i=0;i<n;i++) { drawIstoTrend(xasse,yasse,lab[i],val[i],sc,&tela,i); }

  // Stampo il tutto a video
 	_pic->setPixmap(QPixmap::fromImage(*pic));
  _pic->setGeometry(0,0,pic->width(),pic->height());
 }

QDate ARStat::prendiDataInizioTrend()
 {
 	MYSQL_RES *rs=NULL;
 	MYSQL_ROW row; 	
 	QString pat,tipo;

  tipo=listaStep->itemData(listaStep->currentIndex()).toString();
  if(tipo=="0") // Per anni
   {
    rs=sql->doQueryRS("SELECT DISTINCT SUBSTRING(data_sr,1,4) AS d, SUM(prezzo_pub-(prezzo+prezzo*(iva/100))) AS guadagno FROM articoli WHERE stato=1 GROUP BY d ORDER BY d");
    pat="yyyy";
   }
  if(tipo=="1") // Per mesi
   {
    rs=sql->doQueryRS("SELECT DISTINCT SUBSTRING(data_sr,1,7) AS d, SUM(prezzo_pub-(prezzo+prezzo*(iva/100))) AS guadagno FROM articoli WHERE stato=1 GROUP BY d ORDER BY d");
    pat="yyyy-MM";
   }
  if(tipo=="2") // Per giorni
   {
    rs=sql->doQueryRS("SELECT DISTINCT data_sr AS d, SUM(prezzo_pub-(prezzo+prezzo*(iva/100))) AS guadagno FROM articoli WHERE stato=1 GROUP BY d ORDER BY d");
    pat="yyyy-MM-dd";
   }
 	row=mysql_fetch_row(rs);
 	if(mysql_num_rows(rs)==0) { mysql_free_result(rs); return QDate(); }
 	mysql_free_result(rs);
 	QDate aux(QDate::fromString(row[0],pat));
 	return aux;
 }

QDate ARStat::prendiDataFineTrend()
 {
 	MYSQL_RES *rs=NULL;
 	MYSQL_ROW row; 	
 	QString pat,tipo;

  tipo=listaStep->itemData(listaStep->currentIndex()).toString();
  if(tipo=="0") // Per anni
   {
 	  rs=sql->doQueryRS("SELECT DISTINCT SUBSTRING(data_sr,1,4) AS d, SUM(prezzo_pub-(prezzo+prezzo*(iva/100))) AS guadagno FROM articoli WHERE stato=1 GROUP BY d ORDER BY d DESC");
 	  pat="yyyy";
 	 }  
  if(tipo=="1") // Per mesi
   {
 	  rs=sql->doQueryRS("SELECT DISTINCT SUBSTRING(data_sr,1,7) AS d, SUM(prezzo_pub-(prezzo+prezzo*(iva/100))) AS guadagno FROM articoli WHERE stato=1 GROUP BY d ORDER BY d DESC");
 	  pat="yyyy-MM";
 	 }
  if(tipo=="2") // Per giorni
   {
 	  rs=sql->doQueryRS("SELECT DISTINCT data_sr AS d, SUM(prezzo_pub-(prezzo+prezzo*(iva/100))) AS guadagno FROM articoli WHERE stato=1 GROUP BY d ORDER BY d DESC");
 	  pat="yyyy-MM-dd";
 	 }
 	row=mysql_fetch_row(rs);
 	if(mysql_num_rows(rs)==0) { mysql_free_result(rs); return QDate(); }
 	mysql_free_result(rs);
 	QDate aux(QDate::fromString(row[0],pat));
 	return aux;
 }

int ARStat::prendiNumDatiTrend(QDate data_iniz,QDate data_fine)
 {
  int n=0;
  QDate aux=data_iniz;
  QString tipo;
  
  tipo=listaStep->itemData(listaStep->currentIndex()).toString();
  if(tipo=="0") // Per anni
   while(aux<=data_fine) { aux=aux.addYears(1);  n++; }
  if(tipo=="1") // Per mesi
 	 while(aux<=data_fine) { aux=aux.addMonths(1); n++; }
  if(tipo=="2") // Per giorni
 	 while(aux<=data_fine) { aux=aux.addDays(1); n++; }
 	return n;
 }

void ARStat::prendiDatiTrend(QString lab[],QString val[],QDate data_iniz,QDate data_fine)
 {
 	MYSQL_RES *rs=NULL;
 	MYSQL_ROW row;
 	QString tipo;
 	int i=0;

  tipo=listaStep->itemData(listaStep->currentIndex()).toString();
 	if(tipo=="0") // Prendo i dati per anni
 	 rs=sql->doQueryRS("SELECT DISTINCT SUBSTRING(data_sr,1,4) AS d, SUM(prezzo_pub-(prezzo+prezzo*(iva/100))) AS guadagno FROM articoli WHERE stato=1 GROUP BY d ORDER BY d"); // Prende tutti gli anni e i guadagni annuali
 	if(tipo=="1") // Prendo i dati per mesi
 	 rs=sql->doQueryRS("SELECT DISTINCT SUBSTRING(data_sr,1,7) AS d, SUM(prezzo_pub-(prezzo+prezzo*(iva/100))) AS guadagno FROM articoli WHERE stato=1 GROUP BY d ORDER BY d"); // Prende tutti i mesi e i guadagni mensili
 	if(tipo=="2") // Prendo i dati per giorni
 	 rs=sql->doQueryRS("SELECT DISTINCT data_sr AS d, SUM(prezzo_pub-(prezzo+prezzo*(iva/100))) AS guadagno FROM articoli WHERE stato=1 GROUP BY d ORDER BY d"); // Prende tutti i giorni e i guadagni giornalieri
 	if(mysql_num_rows(rs)==0) { mysql_free_result(rs); return; }
 	row=mysql_fetch_row(rs);
 	while(data_iniz<=data_fine)
 	 {
 	 	if(tipo=="0") lab[i]=data_iniz.toString("yyyy");
 	 	if(tipo=="1") lab[i]=data_iniz.toString("yyyy-MM");
 	 	if(tipo=="2") lab[i]=data_iniz.toString("yyyy-MM-dd"); 	 	
 	 	if(lab[i]==QString(row[0])) { val[i]=row[1]; row=mysql_fetch_row(rs); }	else val[i]="0";
 	 	if(tipo=="0")
 	 	 {
 	 	  lab[i]=data_iniz.toString("yyyy");
 	 	  data_iniz=data_iniz.addYears(1);
 	 	 }
 	  if(tipo=="1")
 	   {
 	 	  lab[i]=data_iniz.toString("MMM-yy");
 	 	  data_iniz=data_iniz.addMonths(1);
 	   }
 	  if(tipo=="2")
 	   {
 	 	  lab[i]=data_iniz.toString("dd-MM-yy");
 	 	  data_iniz=data_iniz.addDays(1);
 	   }
 	 	i++;
 	 }
 	mysql_free_result(rs);
 }

int ARStat::drawAssiTrend(int maxy,int miny,int alt,double sc,QPainter *tela,QString labx,QString laby)
 {
 	int yasse,xasse,i=0;

  yasse=(int)((double)maxy/(double)alt*((double)pic->height()));
  if(maxy>-miny) yasse+=-50; else yasse+=50;
  xasse=0+50;
  // Valori intermedi lungo asse Y
  tela->setPen(QColor(180,180,180));
  QString aux;
  int passo,dis;
  
  dis=(alt+pic->height())*100/5/100;
  while(i<=alt+pic->height()) // CONTROLLARE
   {
    passo=(int)(100*sc);
    passo=passo-(passo%dis)+dis;
   	i+=passo;
   	//(alt+pic->height()*100)/5/100; // Approssima all'intero pi vicino ad un multiplo di 100 (senza casting :-) )
    int v=(int)(-(double)i*sc);
    QString aux;
    tela->drawText(0,yasse-1+v,aux.sprintf("%d.00",i));
    tela->drawLine(0,yasse+v,pic->width(),yasse+v);
    tela->drawText(0,yasse-1-v,aux.sprintf("%d.00",-i));
    tela->drawLine(0,yasse-v,pic->width(),yasse-v);
   }
  tela->setPen(QColor(0,0,0));
  // Assi
  tela->drawLine(0,yasse,pic->width(),yasse);  // Asse X
  tela->drawText(0,yasse+18,labx);             // Unit asse X
  tela->drawLine(xasse,0,xasse,pic->height()); // Asse Y
  for(int i=0;i<laby.length();i++)             // Unit asse Y
   {
    tela->drawText(34,(i+1)*12,laby.at(i)); 
   }
  return yasse; 	
 }

void ARStat::drawIstoTrend(int xasse,int yasse,QString lab,QString val,double sc,QPainter *tela,int i)
 {
 	int v,lar_ist=25,dist=50;

 	v=-((int)(val.toDouble()*sc));
  val.sprintf("%.2lf",val.toDouble());
  tela->fillRect(xasse+20+dist*i,yasse,lar_ist,v,QBrush(QColor(255,0,0)));
  if(v<=0) tela->drawText(xasse+20+dist*i,yasse-3+v,val);
  else tela->drawText(xasse+20+dist*i,yasse+12+v,val);
  tela->drawText(xasse+20+dist*i,yasse+18,lab);
 }

void ARStat::creaStatistica()
 {
 	int xasse,yasse,maxy,miny,alt,i=0,n=0;
 	double sc;

  // lock tabella articoli in scrittura da qui (devono diventare operazioni atomiche)
 	n=prendiNumDatiStatistica();
 	QString lab[n]; QString val[n];
 	prendiDatiStatistica(lab,val);
 	// a qui

 	// Ricavo max e min
 	maxy=miny=0;
 	for(i=0;i<n;i++)
 	 {
 	 	if((int)val[i].toDouble()>maxy) maxy=(int)val[i].toDouble();
 	 	if((int)val[i].toDouble()<miny) miny=(int)val[i].toDouble();
 	 }
  alt=maxy-miny;     

  // Inizializzo l'immagine e disegno gli assi
  pic2->~QImage();
  if(20+180+n*180>area->width()) pic2 = new QImage(20+160+n*180,area->height()-20,QImage::Format_RGB32);
  else pic2 = new QImage(area->width(),area->height()-20,QImage::Format_RGB32);
  pic2->fill(0xFFFFFF);
  QPainter tela(pic2);
  int pic_alt=(int)((double)pic2->height()/(double)1.6);
  if(alt==0) alt=1;
  sc=(double)pic_alt/(double)alt;

  QString tipo=listaMostra2->itemData(listaMostra2->currentIndex()).toString();
  if(tipo=="0") { tipo="CLIENTI"; }
  if(tipo=="1") { tipo="FORNITORI"; }
  if(tipo=="2") { tipo="TIPOLOGIE"; }
  yasse=drawAssiStatistica(maxy,miny,alt,sc,&tela,tipo,"EURO");
  xasse=0+50;
  
  // Disegno il grafico
  for(i=0;i<n;i++) { drawIstoStatistica(xasse,yasse,lab[i],val[i],sc,&tela,i); }

  // Stampo il tutto a video
 	_pic2->setPixmap(QPixmap::fromImage(*pic2));
  _pic2->setGeometry(0,0,pic2->width(),pic2->height());
 }

int ARStat::prendiNumDatiStatistica()
 {
 	MYSQL_RES *rs=NULL;
 	QString tipo;
 	int n;

  tipo=listaMostra2->itemData(listaMostra2->currentIndex()).toString();
  if(tipo=="0") // Per clienti
   rs=sql->doQueryRS("SELECT clienteID FROM clienti");
  if(tipo=="1") // Per fornitori
   rs=sql->doQueryRS("SELECT fornitoreID FROM fornitori");
  if(tipo=="2") // Per tipologia merceologica
   rs=sql->doQueryRS("SELECT tipo_articoloID FROM tipi_articolo");  
 	n=mysql_num_rows(rs);
 	mysql_free_result(rs);
 	return n;
 }

void ARStat::prendiDatiStatistica(QString lab[],QString val[])
 {
 	MYSQL_RES *rs=NULL,*rs2=NULL;
 	MYSQL_ROW row,row2;
 	QString tipo;
 	int i=0;

  tipo=listaMostra2->itemData(listaMostra2->currentIndex()).toString();
 	if(tipo=="0") // Prendo i dati per clienti
   {
   	rs=sql->doQueryRS("SELECT clienteID,nome FROM clienti ORDER BY nome");
   	rs2=sql->doQueryRS("SELECT clienti.clienteID,SUM(prezzo_pub-(prezzo+prezzo*(iva/100))) AS guadagno,COUNT(*) AS pezzi,nome FROM clienti,articoli WHERE stato=1 AND articoli.clienteID=clienti.clienteID GROUP BY clienti.clienteID ORDER BY nome");
   }
 	if(tipo=="1") // Prendo i dati per fornitori
   {
   	rs=sql->doQueryRS("SELECT fornitoreID,nome FROM fornitori ORDER BY nome");
   	rs2=sql->doQueryRS("SELECT fornitori.fornitoreID,SUM(prezzo_pub-(prezzo+prezzo*(iva/100))) AS guadagno,COUNT(*) AS pezzi,nome FROM fornitori,articoli WHERE stato=1 AND articoli.fornitoreID=fornitori.fornitoreID GROUP BY fornitori.fornitoreID ORDER BY nome");
   }
 	if(tipo=="2") // Prendo i dati per tipologia merceologica
   {
  	rs=sql->doQueryRS("SELECT tipo_articoloID,descrizione FROM tipi_articolo ORDER BY descrizione");
   	rs2=sql->doQueryRS("SELECT tipi_articolo.tipo_articoloID,SUM(prezzo_pub-(prezzo+prezzo*(articoli.iva/100))) AS guadagno,COUNT(*) AS pezzi,tipi_articolo.descrizione FROM tipi_articolo,articoli WHERE stato=1 AND articoli.tipo_articoloID=tipi_articolo.tipo_articoloID GROUP BY tipi_articolo.tipo_articoloID ORDER BY tipi_articolo.descrizione");
   }
 	if(mysql_num_rows(rs)==0) { mysql_free_result(rs); mysql_free_result(rs2); return; }
 	row2=mysql_fetch_row(rs2);
 	while(row=mysql_fetch_row(rs))
 	 {
 	 	val[i]="0";
 	 	if(row2)
 	 	 if(QString(row[0])==QString(row2[0])) { val[i]=row2[1]; row2=mysql_fetch_row(rs2); }
 	  lab[i]=row[1];
 	 	i++;
 	 }
 	mysql_free_result(rs);
 	mysql_free_result(rs2);
 }

int ARStat::drawAssiStatistica(int maxy,int miny,int alt,double sc,QPainter *tela,QString labx,QString laby)
 {
 	int yasse,xasse,i=0;

  yasse=(int)((double)maxy/(double)alt*((double)pic2->height()));
  if(maxy>-miny) yasse+=-50; else yasse+=50;
  xasse=0+50;
  // Valori intermedi lungo asse Y
  tela->setPen(QColor(180,180,180));
  QString aux;
  int passo,dis;
  
  dis=(alt+pic2->height())*100/5/100;
  while(i<=alt+pic2->height()) // CONTROLLARE
   {
    passo=(int)(100*sc);
    passo=passo-(passo%dis)+dis;
   	i+=passo;
   	//(alt+pic2->height()*100)/5/100; // Approssima all'intero pi vicino ad un multiplo di 100 (senza casting :-) )
    int v=(int)(-(double)i*sc);
    QString aux;
    tela->drawText(0,yasse-1+v,aux.sprintf("%d.00",i));
    tela->drawLine(0,yasse+v,pic2->width(),yasse+v);
    tela->drawText(0,yasse-1-v,aux.sprintf("%d.00",-i));
    tela->drawLine(0,yasse-v,pic2->width(),yasse-v);
   }
  tela->setPen(QColor(0,0,0));
  // Assi
  tela->drawLine(0,yasse,pic2->width(),yasse);  // Asse X
  tela->drawText(0,yasse+18,labx);             // Unit asse X
  tela->drawLine(xasse,0,xasse,pic2->height()); // Asse Y
  for(int i=0;i<laby.length();i++)             // Unit asse Y
   {
    tela->drawText(34,(i+1)*12,laby.at(i)); 
   }
  return yasse; 	
 }

void ARStat::drawIstoStatistica(int xasse,int yasse,QString lab,QString val,double sc,QPainter *tela,int i)
 {
 	int v,lar_ist=30,dist=180;

 	v=-((int)(val.toDouble()*sc));
  val.sprintf("%.2lf",val.toDouble());
  tela->fillRect(xasse+20+dist*i,yasse,lar_ist,v,QBrush(QColor(255,0,0)));
  if(v<=0) tela->drawText(xasse+20+dist*i,yasse-3+v,val);
  else tela->drawText(xasse+20+dist*i,yasse+12+v,val);
  tela->drawText(xasse+20+dist*i,yasse+18,lab);
 }

bool ARStat::setForm(int t)
 {
  tab->setCurrentIndex(t);
  creaRiepilogo();
  return true;
 }

bool ARStat::checkForm()
 {
 	/*if(quote(this->nome->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire il nome del cliente"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(this->note->toPlainText()).length()>1024)
 	 {
 	  warnbox->setText(tr("Campo note troppo lungo,\nmassimo 1000 caratteri."));
 	  warnbox->exec();
 	  return true;
 	 }*/
 	return false;
 }

void ARStat::settaGeometria(int lar, int alt)
 {
  setGeometry(0,61,lar,alt-70);
 	tab->setGeometry(3,3,lar-5,alt-115);
 	// Riepilogo
  riep->setGeometry  (10,10,lar-25,alt-185);
  stampa1->setGeometry(lar-110,alt-170,96,24);

  // Andamenti
  stampa2->setGeometry(lar-110,alt-170,96,24);
  area->setGeometry(10,70,lar-30,alt-255);
  cornice->setGeometry(10,0,lar-30,60);
  creaTrend();

  // Statistche
  stampa3->setGeometry(lar-110,alt-170,96,24);
  area2->setGeometry(10,70,lar-30,alt-255);
  cornice2->setGeometry(10,0,lar-30,60);
  creaStatistica();
 }

QString ARStat::quote(QString str, bool like)
 {
 	if(like)
 	 {
 	  str.replace('\\',"\\\\\\\\");
 	  str.replace('\'',"\\'");
 	 }
 	else
   {
 	  str.replace('\\',"\\\\");
 	  str.replace('\'',"\\'");
   }
 	return str;
 }

