#ifndef ARSQL_H
#define ARSQL_H

#define ARSQL_NOERR    0
#define ARSQL_CONERR   1
#define ARSQL_QUERYERR 2

#define ARSTATO_GIACENZA           "0"
#define ARSTATO_VENDUTO            "1"
#define ARSTATO_RESO               "2"
#define ARSTATO_GIACENZA_ALLA_DATA "3"

#define CFG_FILE     "config.cfg"
#define ADVCFG_FILE  "advance_config.cfg"
#define RESETDB_FILE "query/resetDB.sql"

class QString;
class QDateTime;
class QFile;
class QTextStream;
class QMessageBox;

#include <iostream>
using namespace std;

#ifdef WIN32
#include <winsock2.h>
#endif

#include <mysql.h>

class ARsql : public QWidget
 {
  private:
   QString lastID;
   MYSQL mysql;
   int lastError;
   int lastAffected;
   char SERVER_ADDR[255];
   char SERVER_PORT[255];
   char USER_LOG[255];
   char USER_PWD[255];
   char DB_NAME[255];  
   QMessageBox *infobox,*warnbox,*errorbox;
   bool connesso;

   void readConfig();

  public:
   ARsql(QWidget *parent = 0);
   bool connetti();
   void disconnetti();
   void faiQuery(string,bool settaLID=false);
   void faiQuery(const char *,bool settaLID=false);
   MYSQL_RES *faiQueryRS(string);
   MYSQL_RES *faiQueryRS(const char *);
   void faiQueryPer(string,bool settaLID=false);
   void faiQueryPer(const char *,bool settaLID=false);
   MYSQL_RES *faiQueryRSPer(string);
   MYSQL_RES *faiQueryRSPer(const char *);
   bool doQuery(const char *,bool settaLID=false);
   bool doQuery(string,bool settaLID=false);
   bool doQuery(QString,bool settaLID=false);
   MYSQL_RES *doQueryRS(const char *);
   MYSQL_RES *doQueryRS(string);
   MYSQL_RES *doQueryRS(QString);
   bool doQueryPer(const char *,bool settaLID=false);
   bool doQueryPer(string,bool settaLID=false);
   bool doQueryPer(QString,bool settaLID=false);
   MYSQL_RES *doQueryRSPer(const char *);
   MYSQL_RES *doQueryRSPer(string);
   MYSQL_RES *doQueryRSPer(QString);
   bool bloccaPer(QString,QString);
   bool isBloccatoPer(QString);
   QString prendiLastID();
   QString prendiPwd();
   bool isError(int);
   QString data(QString,bool eng=true);
   QString ora(QString);
   QString dataTempo(QString);
   QString timeStamp();
   double getDbVersion();
   QString getPref(int,QString);
   bool testConnection();
   bool testDbExist();
   bool testDbEmpty();
   bool testDbNeedUpdate();
   bool testDbBadVersion();
   int getAffected();
   QString getServerAddr();
   QString getServerPort();
   QString getUserLog();
   QString getUserPwd();
   QString getDbName();
   void writeConfig(QString, QString, QString, QString, QString);
   void createDb();
   void resetDb();
   void updateDb();
   bool isConnesso();
 };

#endif
